#! /Library/Frameworks/Python.framework/Versions/Current/bin python

import sys
import os
import ir

path = os.path.abspath(sys.argv[1]);
print path;

TimingOutput = 'Timing.txt';

MrcToMosaicStart = 0;
MrcToTifStart = 0;
TranslateStart = 0;
RefineStart = 0;
AssembleStart = 0;
StosBruteStart = 0;
StosGridStart = 0;

MrcToMosaicStart = time.time();
ir.MRCsToMosaic(path);
MrcToMosaicEnd = time.time();

MrcToTifStart = time.time();
ir.MRCsToTIF(path);
MrcToTifEnd = time.time();

TranslateStart = time.time(); 
ir.Translate(path);
TranslateEnd = time.time();

RefineStart = time.time(); 
ir.Refine(path);
RefineEnd = time.time(); 

AssembleStart = time.time();
ir.Assemble(path);
AssembleEnd = time.time();

StosBruteStart = time.time();
ir.StosBrute(path);
StosBruteEnd = time.time();

StosGridStart = time.time();
ir.StosGrid(path);
StosGridEnd = time.time(); 

#Display elasped time
TFile = open(TimingOutput, 'w+');

tdelta = MrcToMosaicEnd - MrcToMosaicStart; 
s = 'Mrc to Mosaic Time : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = MrcToTifEnd - MrcToTifStart; 
s = 'Mrc to TIF Time    : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = TranslateEnd - TranslateStart; 
s = 'Translate Time     : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = RefineEnd - RefineStart; 
s = 'Refine Time        : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = AssembleEnd - AssembleStart; 
s = 'Assemble Time      : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = StosBruteEnd - StosBruteStart; 
s = 'Stos Brute Time    : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = StosGridEnd - StosGridStart; 
s = 'Stos Grid Time     : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);



