#! /Library/Frameworks/Python.framework/Versions/Current/bin/ python

import sys
import os
import ir
import time

if(len(sys.argv) < 2 or len(sys.argv) > 3):
    print sys.argv[0] + " <path> [TileOverlapInPixels]";
    print "Executes ir-tools to build light microscope mosaics with meta-data on tile";
    print "position stored in .pmg files (Generated by saving Synchroscan workspace)."
    print "All directories under path are checked for workspaces and all found workspaces"
    print "are mosaic'ed and assembled";
    print "TileOverlapInPixels is an optional parameter that should equal the tile"
    print "overal value specified in Synchroscan"  
    sys.exit(0);

TileOverlap = 128;
if(len(sys.argv) >= 3):
    TileOverlap = sys.argv[2]; 
    
path = sys.argv[1];
print path;

ir.ConvertAllPMG(path, TileOverlap);

TranslateStartTime = time.time();
ir.Translate(path, 1, '8-bit');
TranslateEndTime = time.time(); 

RefineStartTime = time.time();
ir.Refine(path,1,'8-bit');
RefineEndTime = time.time();

AssembleStartTime = time.time(); 
ir.Assemble(path,[1],'8-bit');
AssembleEndTime = time.time();

tdelta = TranslateEndTime - TranslateStartTime; 
print 'Translate Time   : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
tdelta = RefineEndTime - RefineStartTime; 
print 'Refine Time   : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
tdelta = AssembleEndTime - AssembleStartTime; 
print 'Assemble Time : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))



