#! /Library/Frameworks/Python.framework/Versions/Current/bin python

import sys
import os
import ir
import time

path = os.path.abspath(sys.argv[1]);
print path;

TimingOutput = 'Timing.txt';

MrcToMosaicStart = 0;
MrcToTifStart = 0;
BuildPyramidStart = 0; 

#Clean up old temporary files
#ir.CleanTempFiles(path);

#Put all .mrc files in thier own directory, doesn't work for multiple volumes

ir.MRCMove(path); 

MrcToMosaicStart = time.time();
ir.MRCsToMosaic(path);
MrcToMosaicEnd = time.time();

MrcToTifStart = time.time();
#ir.MRCsTo16BitPNGs(path);
ir.MRCsTo8BitPNG(path);
MrcToTifEnd = time.time();

BuildPyramidStart = time.time();
ir.BuildPyramids(path);
BuildPyramidEnd = time.time(); 

#Display elasped time
TFile = open(TimingOutput, 'w+');

tdelta = MrcToMosaicEnd - MrcToMosaicStart; 
s = 'Mrc to Mosaic Time : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = BuildPyramidEnd - BuildPyramidStart; 
s = '\nBuildPyramids Time    : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

tdelta = MrcToTifEnd - MrcToTifStart; 
s = '\nMrc to TIF Time    : %2d days %s' % (tdelta / (60 * 60 * 24), time.strftime('%H:%M:%S', time.gmtime(tdelta)))
print s;
TFile.write(s);

TFile.close();
