import sys
import os
import Image
import glob
import ir

if(len(sys.argv) != 4):
    print sys.argv[0] + " <path> <From image ext> <To image ext>";
    print "Uses Python Imaging Library to convert all images in the specified directory";
    print "and all subdirectories with the source image type to the target image type."
    print "Valid extensions are any image extension recognized by the Python Imaging Library,"
    print "but this script was written to convert BMP to PNG";
    print ""
    print "EXAMPLE: " + str(sys.argv[0]) + " <path> bmp png"
    print "Converts all bmp in the specified directory tree into PNG images"
    sys.exit(0);


    
RootPath = sys.argv[1];
#Get all of the directories we should convert images within
DirList = ir.RecurseSubdirectories(RootPath);

StartingPath = os.getcwd(); 

SourceExt = sys.argv[2];
TargetExt = sys.argv[3];

print "Converting from " + SourceExt + " to " + TargetExt;
print "Path: " + RootPath; 

#Check each directory for images
for Path in DirList:
    os.chdir(Path);
    
    Mosaics = glob.glob(os.path.join(Path, "*.mosaic"));
    for MosaicPath in Mosaics:
        f = file(MosaicPath, "r");

        newlines = list();
        lines = f.readlines();
        for line in lines:
            newline = line.replace('.' + SourceExt, '.' + TargetExt);
            newlines.append(newline); 

        f.close();

        print newlines; 

        f = file(MosaicPath, "w");
        f.writelines(newlines);
        f.close(); 
        
os.chdir(StartingPath);
