/*  MosaicBuilder
    Copyright (C) 2007 Spaltenstein Natural Image

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#import <Cocoa/Cocoa.h>
#import "MBMosaicView.h"
#import "MBMosaicContainerView.h"

#define kMBTileTextureList @"tileTextureList"


@interface MBMosaicWindowController : NSWindowController {
    IBOutlet NSOutlineView*			layersView;
    IBOutlet MBMosaicView*			mosaicView;
    IBOutlet NSView*				mosaicContainerView;
 	
	// I think this is bogues and should not live here
	NSMutableArray* loadTextureNames; // array of dictionaries. each dictionary has a kMBLayerID, and kMBTileTextureList
							// kMBTileTextureList is an NSMutableArray of dictionaries. each of these dictionaries has
							// kMBID and an NSValue pointing to the textureName (char*) of the tile
							
	
//	NSMutableDictionary* activeLayer; // this is the layer that is loaded
}

- (id)init;

- (void)dealloc;

- (NSOutlineView*) layersView;
- (void) setLayersView:(NSOutlineView*) view;
- (MBMosaicView*) mosaicView;
- (void) setMosaicView:(MBMosaicView*) view;
- (NSView*) mosaicContainerView;

- (BOOL) validateMenuItem:(NSMenuItem *)item;

- (IBAction) delete: (id) sender;
- (IBAction) changeColor: (id) sender;

- (IBAction) makeAllOpaque: (id) sender;
- (IBAction) makeLayerOpaque: (id) sender;

- (void)keyDown:(NSEvent *)theEvent;
- (void)mouseMoved:(NSEvent *)theEvent;
- (void)flagsChanged:(NSEvent *)theEvent;

- (void) layerListChanged:(NSNotification *)notification;
- (void) layerListShouldSelectItem:(NSNotification *)notification;
- (void) brightnessContrastChanged:(NSNotification *)notification;

- (void) loadLayer: (NSDictionary*) layerDict;
- (void) unLoadLayer: (NSDictionary*) layerDict;
- (void) fixLoadStatus: (NSDictionary*) layerDict;

- (NSMutableDictionary*) activeLayer;
- (void) setActiveLayer:(NSDictionary*) layer;

- (void) toggleShowLayer:(NSMutableDictionary*) layer; // layer or transformation
- (void) setLayerColorToValue:(id)object ofLayer:(NSMutableDictionary*)layer; // layer or transformation
- (void) updateLayerColor:(NSMutableDictionary*) layer; // sets the layer to mixed or some other color if needed


- (void) performTrasformationOperation:(NSDictionary*) operation;
- (NSMutableDictionary*) selectedTransformationDict;

- (void)windowDidBecomeKey:(NSNotification *)aNotification;
- (void)windowDidResize:(NSNotification *)aNotification;
//- (void)windowWillClose:(NSNotification *)aNotification;

+ (NSImage*) swatchForColor:(NSColor*) color;
+ (NSMenuItem*) mixedColorsMenuItem;

@end