/*  MosaicBuilder
    Copyright (C) 2007 Spaltenstein Natural Image

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#import <Cocoa/Cocoa.h>
#include <OpenGL/gl.h>

#import "CustomOpenGLView.h"


@interface MBTileView : CustomOpenGLView {
	long textureTileID;
	GLuint* textureName;
}

- (id)initWithFrame:(NSRect)frame;
- (void)dealloc;

+ (NSOpenGLPixelFormat*) pixelFormat;

- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent;
- (BOOL)shouldDelayWindowOrderingForEvent:(NSEvent *)theEvent;

- (void) updateTexture;
- (void) unloadTexture;

- (void) mouseDown:(NSEvent *)theEvent;
- (void) mouseDragged:(NSEvent *)theEvent;
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)isLocal;

- (void) drawRect:(NSRect)rect;
- (void) activeTileViewChanged:(NSNotification *)notification;
- (void) brightnessContrastChanged:(NSNotification *)notification;

@end
