/*  MosaicBuilder
    Copyright (C) 2007 Spaltenstein Natural Image

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#import <Cocoa/Cocoa.h>
#import "MBTileView.h"

@interface MBTileWindowController : NSWindowController
{
    IBOutlet NSOutlineView* outlineView;
    IBOutlet MBTileView* tileView;

    IBOutlet NSSlider*	brightnessSlider;
    IBOutlet NSSlider*	contrastSlider;
    IBOutlet NSButton*	autolevelsButton;
}

- (NSOutlineView*) outlineView;
- (void) setOutlineView:(NSOutlineView*) outline;
- (MBTileView*) tileView;

- (IBAction) brightnessSliderChanged: (id) sender;
- (IBAction) contrastSliderChanged: (id) sender;

- (void) updateBrightnessContrastControls;
- (void) updateHistogram;

- (IBAction) autolevels: (id) sender;
- (IBAction) equalizeHistogram: (id) sender;
- (IBAction) delete: (id) sender;

- (IBAction) toggleBrightnessContrastDrawer: (id) sender;

- (void) tileListChanged:(NSNotification *)notification;
- (void) tileListShouldSelectItem:(NSNotification *)notification;
- (void) brightnessContrastChanged:(NSNotification *)notification;

@end
