// author : Paul Koshevoy
// project: none, this file has been accumulating functions I wrote since 1996

#ifndef TOKENIZER_HXX_
#define TOKENIZER_HXX_


//----------------------------------------------------------------
// Tokenizer
// 
class Tokenizer
{
public:
  Tokenizer(const char & ch = ' '); // ch is the default delimiter
  ~Tokenizer();
  
  Tokenizer & operator << (const char * str);
  
  // first token:
  char * get_first();
  
  // last token:
  char * get_next();
  
  //get a particular token, index is zero based:
  char * get(const unsigned int & token_index);
  
  // length of a particular token:
  inline unsigned int len(const unsigned int & token_index) const
  {
    if (token_index >= number_) return 0;
    return sizes_[token_index];
  }
  
  // returns number of tokens in the string
  inline const unsigned int & count() const
  { return number_; }
  
private:
  // helper function:
  bool is_delimiter(const char & c) const;
  
  // the string being tokenized:
  char * string_;
  unsigned int length_;
  
  // the largest token can be 1024 chars long
  char token_[1024];
  
  // max number of tokens is 1024:
  unsigned int addrs_[1024];
  
  // the sizes of tokens are stored here:
  unsigned int sizes_[1024];

  // current position in the string:
  unsigned int index_;
  
  // number of tokens in the string:
  unsigned int number_;
  
  // the token separator:
  char delimiter_;
};


#endif // TOKENIZER_HXX_
