#ifndef IMAGEGROUP_H
#define IMAGEGROUP_H

#include <QVector>
#include <QGraphicsPixmapItem>
#include <QAction>
#include <stdio.h>

typedef QVector<QGraphicsPixmapItem*> VectorOfImages;
typedef QVector<QAction*> VectorOfActions;

class ImageGroup : public QObject//QGraphicsPixmapItem
{
  Q_OBJECT

public:
  void addImageFromFile (QString imageFileName);
  VectorOfImages imageGroup;
  VectorOfActions actionGroup;
  VectorOfImages getImageGroup ();
  VectorOfActions getActionGroup ();
  QGraphicsPixmapItem* getImageAt (int index);
  QAction* getActionAt (int index);
  QGraphicsPixmapItem* getCurrentImage ();
  QAction* getCurrentAction ();
  int getCurrentImageIndex();
  void setCurrentImage (int activeImage);
  int getNumberOfImages ();
  int getNumberOfActions ();
  void addImageToGroup (QGraphicsPixmapItem* image, QAction* action);
  void removeImageFromGroup (QGraphicsPixmapItem* image);
  void removeImageFromGroup (int imageIndex);
  QString getGroupName();
  void setGroupName(QString groupName);
  void unCheckAllActions();

public slots:
  void setImageVisibilities();
  
private slots:

private:
  QGraphicsPixmapItem *pictureItem;
  int currentImage;
  QString groupName;
  QAction *action;
};

#endif //IMAGEGROUP_H
