#ifndef SYNAPSEGROUP_H
#define SYNAPSEGROUP_H

#include <QVector>
#include <QAction>
#include <QtXml/qdom.h>
#include "SynapseMarker.h"
#include <stdio.h>

typedef QVector<SynapseMarker*> VectorOfSynapses;

class SynapseGroup : public SynapseMarker
{
  Q_OBJECT

public:
  void addSynapsesFromFile (QString synapsesFileName);
  VectorOfSynapses synapseGroup;
  VectorOfSynapses getSynapseGroup ();
  SynapseMarker* getSynapseAt (int index);
  SynapseMarker* getCurrentSynapse ();
  int getCurrentSynapseIndex();
  void setCurrentSynapse (int activeSynapse);
  int getNumberOfSynapses ();
  void addSynapseToGroup (SynapseMarker* synapse);
  void removeSynapseFromGroup (SynapseMarker* synapse);
  void removeSynapseFromGroup (int synapseIndex);
  QAction* getGroupMenuItem();
  QString getGroupName();
  void setGroupName(QString groupName);
  
private slots:
  void toggleGroupVisibility();

private:
  int currentSynapse;
  bool groupVisibility;
  QString groupName;
  QAction *viewGroupPictureAct;

};

#endif //SYNAPSEGROUP_H
