#include <iostream>
#include "SynapseGroupManager.h"

using namespace std;

int SynapseGroupManager::getNumberOfGroups ()
{
  return synapseGroupManager.size();
}

QStringList SynapseGroupManager::getSynapseGroupFileNames ()
{
  QStringList fileNameList;
  for (int iSynapseGroup = 0; iSynapseGroup < this->getNumberOfGroups(); iSynapseGroup ++)
  {
	QString fileName = synapseGroupManager[iSynapseGroup]->getGroupName();
	fileNameList.push_back(fileName);
	cout <<  qPrintable(synapseGroupManager[iSynapseGroup]->getGroupName()) << endl;
  }
  cout << fileNameList.size() << endl;
  return fileNameList;
}

void SynapseGroupManager::addNewSynapseGroup (SynapseGroup* synapseGroup)
{
  synapseGroupManager.push_back(synapseGroup);
  currentSynapseGroup = synapseGroupManager.size() - 1;
  printf ("Setting currentSynapseGroup = %d\n", currentSynapseGroup);
}

void SynapseGroupManager::removeSynapseGroup (SynapseGroup* synapseGroup)
{
  int synapseGroupPosition = synapseGroupManager.indexOf(synapseGroup);
  this->removeSynapseGroup (synapseGroupPosition);
}

void SynapseGroupManager::removeSynapseGroup (int synapseGroupPosition)
{
  synapseGroupManager.remove(synapseGroupPosition);
  currentSynapseGroup = -1;
}

int SynapseGroupManager::getCurrentSynapseGroupIndex ()
{
  return currentSynapseGroup;
}

SynapseGroup* SynapseGroupManager::getCurrentSynapseGroup ()
{
  //printf ("Getting currentSynapseGroup = %d\n", currentSynapseGroup);
  return synapseGroupManager[currentSynapseGroup];
}

SynapseGroup* SynapseGroupManager::getSynapseGroupAt (int groupIndex)
{
  //printf ("Getting currentSynapseGroup = %d\n", groupIndex);
  return synapseGroupManager[groupIndex];
}

void SynapseGroupManager::setCurrentSynapseGroup (int activeSynapseGroup)
{
  currentSynapseGroup = activeSynapseGroup;
}
