#ifndef SYNAPSEGROUPMANAGER_H
#define SYNAPSEGROUPMANAGER_H

#include <QVector>
#include "SynapseGroup.h"

typedef QVector<SynapseMarker*> VectorOfSynapses;

class SynapseGroupManager : public SynapseGroup
{
  Q_OBJECT

public:
  QVector<SynapseGroup*> synapseGroupManager;
  int getCurrentSynapseGroupIndex();
  SynapseGroup* getCurrentSynapseGroup ();
  SynapseGroup* getSynapseGroupAt (int groupIndex);
  QStringList getSynapseGroupFileNames ();
  void setCurrentSynapseGroup(int activeSynapseGroup);
  int getNumberOfGroups ();
  void addNewSynapseGroup (SynapseGroup* synapseGroup);
  void removeSynapseGroup (SynapseGroup* synapseGroup);
  void removeSynapseGroup (int currentSynapseGroup);

private slots:

private:
  int currentSynapseGroup;

};

#endif //SYNAPSEGROUPMANAGER_H

