#ifndef SYNAPSEGROUPPROPERTYEDITOR_H
#define SYNAPSEGROUPPROPERTYEDITOR_H

#include "SynapseGroupManager.h"
#include <QDialog>
#include <QLabel>
#include <QComboBox>
#include <QGridLayout>
#include <QLineEdit>
#include <QColorDialog>
#include <QPushButton>

class SynapseGroupPropertyEditor : public QDialog
{
  Q_OBJECT

public:
  SynapseGroupPropertyEditor ();
  ~SynapseGroupPropertyEditor ();
  void setDialogDefaults(SynapseGroupManager* sgm);

private slots:
  void setColor();
  void OKClickEvent();
  void applyClickEvent();

private:
  SynapseGroupManager *synapseGroupManager;
  QColor color;
  QComboBox *groupListComboBox;
  QLabel *groupListLabel;
  QLabel *colorLabel;
  QLabel *transperancyLabel;
  QLabel *sizeLabel;
  QLabel *defaultOrientationLabel;
  QLineEdit *colorText;
  QLineEdit *transperancyText;
  QLineEdit *sizeText;
  QLineEdit *defaultOrientationText;
  QPushButton *colorButton;
  QPushButton *OKButton;
  QPushButton *applyButton;
  QPushButton *cancelButton;
  QGridLayout *windowLayout;
  void setUpDialogWidgets();
  void setUpDialog();
  void setPropertiesToGroup();
};

#endif //SYNAPSEGROUPPROPERTYEDITOR_H
