#ifndef SYNAPSESMARKER_H
#define SYNAPSESMARKER_H

#pragma once

#include <QGraphicsItem>
#include <QObject>
#include "svMacros.h"

class SynapseMarker : public QObject, public QGraphicsItem
{
  Q_OBJECT

public:
  SynapseMarker();

  void setID (QString id);
  void setType (QString type);
  void setName (QString name);
  void setMarkerLabel (QString markerLabel);
  void setDirection (qreal direction);
  void setColor (QColor color);
  void setPosition (QPointF position);
  void setSize (qreal nSize);

  QString getID ();
  QString getType ();
  QString getName ();
  QString getMarkerLabel ();
  qreal getDirection ();
  QColor getColor ();
  QPointF getPosition ();
  qreal getSize ();

  QRectF boundingRect() const;
  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

//private slots:
private:
  QString Id;
  QString Type;
  QString Name;
  QString MarkerLabel;
  qreal Direction;
  qreal Size;
  QColor Color;
  QPointF Position;
};

#endif //SYNAPSESMARKER_H
