#include "ViewerController.h"

QPushButton* ViewerController::getZoomInButton() {
  return zoomInButton;
}

QPushButton* ViewerController::getZoomOutButton() {
  return zoomOutButton;
}

QPushButton* ViewerController::getMoveUpButton() {
  return moveUpButton;
}

QPushButton* ViewerController::getMoveDownButton() {
  return moveDownButton;
}

QPushButton* ViewerController::getMoveLeftButton() {
  return moveLeftButton;
}

QPushButton* ViewerController::getMoveRightButton() {
  return moveRightButton;
}

QPushButton* ViewerController::getMoveInitPosButton() {
  return moveInitPosButton;
}

QSlider* ViewerController::getScaleSlider() {
	return scaleSlider;
}

ViewerController::ViewerController()
{
  createScalingControls();
  createTranslatingControls();
  QGridLayout *setImageLayout = new QGridLayout();
  setImageLayout->addLayout (translatorsLayout, 1, 1); 
  setImageLayout->addLayout (scalingLayout, 2, 1); 
  this->setLayout (setImageLayout);
  this->setFixedSize (100,280);
  this->setWindowOpacity (0);
}

ViewerController::~ViewerController()
{
  //Destroy all objects created
}

void ViewerController::createScalingControls()
{
  scaleSlider = new QSlider();
  scaleSlider->setRange(0, 100);
  scaleSlider->setValue(100);
  scaleSlider->setPageStep(10);
  scaleSlider->setTickPosition (QSlider::TicksBothSides);
  scaleSlider->setFixedSize (20, 100);

  zoomInButton = new QPushButton ("+");
  zoomInButton->setFixedSize (20, 20);
  
  zoomOutButton = new QPushButton ("-");
  zoomOutButton->setFixedSize (20, 20);
  
  scalingLayout = new QGridLayout();
  scalingLayout->addWidget (zoomInButton,1,2);
  scalingLayout->addWidget (scaleSlider,2,2);
  scalingLayout->addWidget (zoomOutButton,3,2);
  scalingLayout->setAlignment(Qt::AlignCenter);
}

void ViewerController::createTranslatingControls()
{
  translatorsLayout = new QGridLayout();
  moveUpButton = new QPushButton ("^1");
  moveDownButton = new QPushButton ("v");
  moveLeftButton = new QPushButton ("<");
  moveRightButton = new QPushButton (">");
  moveInitPosButton = new QPushButton ("#");
  translatorsLayout->addWidget(moveUpButton,1,2);
  translatorsLayout->addWidget(moveDownButton,3,2);
  translatorsLayout->addWidget(moveLeftButton,2,1);
  translatorsLayout->addWidget(moveRightButton,2,3);
  translatorsLayout->addWidget(moveInitPosButton,2,2);
  moveUpButton->setFixedSize (20, 20);
  moveDownButton->setFixedSize (20, 20);
  moveLeftButton->setFixedSize (20, 20);
  moveRightButton->setFixedSize (20, 20);
  moveInitPosButton->setFixedSize (20, 20);
  translatorsLayout->setSpacing(5);
  translatorsLayout->setMargin(5);
}