#ifndef VIEWERCONTROLLER_H
#define VIEWERCONTROLLER_H

#include <QGroupBox>
#include <QPushButton>
#include <QSlider>
#include <QAction>
#include <QGridLayout>

class ViewerController : public QGroupBox
{
  Q_OBJECT

public:
  ViewerController();
  ~ViewerController();
  QPushButton* getZoomInButton();
  QPushButton* getZoomOutButton();
  QPushButton* getMoveUpButton();
  QPushButton* getMoveDownButton();
  QPushButton* getMoveLeftButton();
  QPushButton* getMoveRightButton();
  QPushButton* getMoveInitPosButton();
  QSlider* getScaleSlider();

private:
  void createActions();
  void createScalingControls();
  void createTranslatingControls();

  QGridLayout *scalingLayout;
  QGridLayout *translatorsLayout;

  QPushButton *zoomInButton;
  QPushButton *zoomOutButton;
  QPushButton *moveUpButton;
  QPushButton *moveDownButton;
  QPushButton *moveLeftButton;
  QPushButton *moveRightButton;
  QPushButton *moveInitPosButton;
  QSlider *scaleSlider;
};

#endif //VIEWERCONTROLLER_H