// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : ImageProcessingDialog.h
// Author       : Pavel A. Koshevoy
// Created      : Tue Jul 25 16:30:00 MDT 2006
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A modal dialog for the image processing thread.

#ifndef IMAGE_PROCESSING_DIALOG_H_
#define IMAGE_PROCESSING_DIALOG_H_

// local includes:
#include "ui_ImageProcessingDialog.h"
#include "image_data.hxx"

// thelib includes:
#include <Qt/the_qt_thread.hxx>

// Qt includes:
#include <QDialog>


//----------------------------------------------------------------
// ImageProcessingDialog
// 
class ImageProcessingDialog : public QDialog,
			      public Ui::ImageProcessingDialog
{
  Q_OBJECT
  
public:
  ImageProcessingDialog(QWidget * parent = 0, Qt::WFlags f = 0);
  ~ImageProcessingDialog();
  
public slots:
  int exec();
  
  void startThread();
  void cancel();
  
  void transactionFinished(the_transaction_t * t);
  void updateStatus(const QString & status);
  void threadStopped(the_thread_interface_t * thread,
		     bool all_transaction_completed);
  
protected:
  // virtual:
  void closeEvent(QCloseEvent * e);
  
public:
  // the worker:
  the_qt_thread_t thread_;
};


#endif // IMAGE_PROCESSING_DIALOG_H_
