// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : ThreadPoolDialog.h
// Author       : Pavel A. Koshevoy
// Created      : Thu Mar 22 08:55:35 MDT 2007
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A modal dialog for the image processing thread pool.

#ifndef THREAD_POOL_DIALOG_H_
#define THREAD_POOL_DIALOG_H_

// local includes:
#include "ui_ThreadPoolDialog.h"

// the includes:
#include <Qt/the_qt_thread_pool.hxx>
#include <utils/the_dynamic_array.hxx>

// Qt includes:
#include <QDialog>


//----------------------------------------------------------------
// ThreadPoolDialog
// 
class ThreadPoolDialog : public QDialog,
			 public Ui::ThreadPoolDialog
{
  Q_OBJECT
  
public:
  ThreadPoolDialog(unsigned int num_threads,
		   QWidget * parent = 0,
		   Qt::WFlags f = 0);
  ~ThreadPoolDialog();
  
public slots:
  int exec();
  
  void startThread();
  void cancel();
  
  void transactionFinished(the_transaction_t * t);
  void updateStatus(const QString & status);
  
protected:
  // virtual:
  void closeEvent(QCloseEvent * e);
  
public:
  // the worker:
  the_qt_thread_pool_t pool_;
};


#endif // THREAD_POOL_DIALOG_H_
