// -*- Mode: c++; tab-width: 4; c-basic-offset: 4; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// File         : IRConnection.xx
// Author       : Joel Spaltenstein
// Created      : 2008/02/19
// Copyright    : (C) 2008 University of Utah
// License      : GPLv2
// Description  : 

#ifndef __IR_CONNECTION_HXX__
#define __IR_CONNECTION_HXX__

#include <vector>

#include <itk/common.hxx>

class IRTransform;

class IRConnection
{
public:
	IRConnection(IRTransform* fristTransform, IRTransform* secondTransform);
	~IRConnection();
	
	vec2d_t tensionOnTransformation(IRTransform* transform);
	vec2d_t idealTransormationOffset();
	
	IRTransform* firstTransformation() {return _firstTransformation;}
	IRTransform* secondTransformation() {return _secondTransformation;}
	
	int findIdealOffset();
	
private:
	IRTransform* _firstTransformation;
	IRTransform* _secondTransformation;
	
	vec2d_t _idealTransormationOffset;
	double _matchValue;
};

#endif


