TEMPLATE	= app
LANGUAGE	= C++
TARGET		= ir-track
PROJECTNAME	= ir-track

QT += opengl

CONFIG	-= release
CONFIG	-= debug
CONFIG	+= qt gui rtti exceptions opengl warn_on thread console
#CONFIG	+= debug
CONFIG	+= release

DEFINES += USE_ITK_TERMINATORS
#DEFINES += USE_LEGENDRE
DEFINES += USE_CG
#DEFINES += DEBUG_TEXTURES

RESOURCES += resources.qrc

HEADERS	+= \
        shader_la.hxx \
        shader_la2.hxx \
	image_data.hxx \
        LoadMosaicTransactionITK.h \
        LoadMosaicTransaction.h \
        StdTileTransaction.h \
        ImageDataTransaction.h \
        ImageProcessingDialog.h \
        PreferencesDialog.h \
	the_track_proc.hxx \
	the_main_window.hxx \
	the_track_proc_ui.hxx


SOURCES	+= the_main.cxx \
        PreferencesDialog.cpp \
        ImageProcessingDialog.cpp \
	the_track_proc.cxx \
	the_main_window.cxx \
	the_track_proc_ui.cxx

FORMS	= MainWindow.ui \
	LabelDialog.ui \
        ShrinkFactorDialog.ui \
        ImageProcessingDialog.ui \
        AboutDialog.ui \
        PreferencesDialog.ui

LIBS	+=	-L$$(THE_BIN_DIR) -lthe_ui_qt -lthe_ui -lthe_itk -lthe_core \
		-L$$(FFTW_DIR)/lib -lfftw3 \
		-L$$(ITK_DIR)/bin \
		-lITKNumerics \
                -lITKIO \
                -lITKNrrdIO \
                -litkgdcm \
                -litkjpeg12 \
                -litkjpeg16 \
                -litkopenjpeg \
                -litkpng \
                -litktiff \
                -litkjpeg8 \
                -lITKSpatialObject \
                -lITKNumerics \
                -lITKCommon \
                -litkvnl_inst \
                -litkvnl_algo \
                -litkv3p_netlib \
                -litkvnl \
                -litkvcl \
                -lm \
                -lITKMetaIO \
                -litksys \
                -lITKDICOMParser \
                -lITKEXPAT \
                -lITKniftiio \
                -lITKznz \
                -litkzlib \
                -lm

#LIBS	+= -lefence
macx {
LIBS	+=	-framework Cg -L$$(GLEW_DIR)/lib -lGLEW
} else {
LIBS	+=	-L$$(CG_LIB_DIR) -lCg -lCgGL \
		-Wl,-Bstatic -L$$(GLEW_DIR)/lib -lGLEW -Wl,-Bdynamic
}

INCLUDEPATH +=	$$(THE_SRC_DIR) \
		$$(BOOST_INCLUDEDIR) \
		$$(GLEW_DIR)/include \
		$$(CG_DIR)/include \
		$$(FFTW_DIR)/include \
		$$(ITK_DIR)/Utilities/vxl/core \
		$$(ITK_DIR)/Utilities/vxl/vcl \
		$$(ITK_SOURCE_DIR)/Utilities/vxl/core \
		$$(ITK_SOURCE_DIR)/Utilities/vxl/vcl \
		$$(ITK_SOURCE_DIR)/Utilities \
		$$(ITK_DIR)/Utilities \
		$$(ITK_DIR)/Utilities/gdcm \
		$$(ITK_SOURCE_DIR)/Utilities/nifti/znzlib \
		$$(ITK_SOURCE_DIR)/Utilities/nifti/niftilib \
		$$(ITK_SOURCE_DIR)/Utilities/expat \
		$$(ITK_DIR)/Utilities/expat \
		$$(ITK_DIR)/Utilities/DICOMParser \
		$$(ITK_SOURCE_DIR)/Utilities/DICOMParser \
		$$(ITK_SOURCE_DIR)/Utilities/NrrdIO \
		$$(ITK_SOURCE_DIR)/Utilities/MetaIO \
		$$(ITK_SOURCE_DIR)/Code/SpatialObject \
		$$(ITK_SOURCE_DIR)/Code/Numerics/NeuralNetworks \
		$$(ITK_SOURCE_DIR)/Code/Numerics/Statistics \
		$$(ITK_SOURCE_DIR)/Code/Numerics/FEM \
		$$(ITK_SOURCE_DIR)/Code/IO \
		$$(ITK_SOURCE_DIR)/Code/Numerics \
		$$(ITK_SOURCE_DIR)/Code/Common \
		$$(ITK_SOURCE_DIR)/Code/BasicFilters \
		$$(ITK_SOURCE_DIR)/Code/Algorithms \
		$$(ITK_DIR)


DEPENDPATH	= ./

UI_DIR = ui
MOC_DIR = moc

debug {
  message(configuring DEBUGGING build)
# OBJECTS_DIR = ./obj/$$(CPU)/debug
  OBJECTS_DIR = /scratch/$$(CPU)/ir-track/debug
  linux-g++:QMAKE_CXXFLAGS	+= -fno-inline -g3 -O0 -DDEBUG
  linux-g++-64:QMAKE_CXXFLAGS	+= -fno-inline -g3 -O0 -DDEBUG
  macx-g++:QMAKE_CXXFLAGS	+= -fno-inline
  DEFINES += DEBUG
#  DEFINES += _GLIBCXX_DEBUG
}

release {
  message(configuring RELEASE build)
# OBJECTS_DIR = ./obj/$$(CPU)/release
  OBJECTS_DIR = /scratch/$$(CPU)/ir-track/release
  linux-g++:QMAKE_CXXFLAGS	+= -finline
  linux-g++-64:QMAKE_CXXFLAGS	+= -finline
  macx-g++:QMAKE_CXXFLAGS	+= -finline
  DEFINES += NDEBUG
}

win32 {
  RC_FILE = ir-track.rc
  CONFIG(debug) {
    OBJECTS_DIR = obj\win32dbg
  } else {
    OBJECTS_DIR = obj\win32rel
  }
  
# DEFINES = _USE_MATH_DEFINES NOMINMAX uint64_t=__int64
  DEFINES += _USE_MATH_DEFINES NOMINMAX
  LIBS += -lws2_32 -lsnmpapi -lgdi32

  CONFIG -= console
}

macx {
  ICON = ir-track.icns
  CONFIG -= console
  UI_DIR = ./osx
  MOC_DIR = ./osx
  
  QMAKE_MAC_SDK = /Developer/SDKs/MacOSX10.4u.sdk
  
  CONFIG(debug) {
    OBJECTS_DIR = ./osx/$$(CPU)/debug
  } else {
    OBJECTS_DIR = ./osx/$$(CPU)/release
    CONFIG += x86 ppc
  }
}

#linux-g++:QMAKE_LFLAGS		+= -pg
#linux-g++:QMAKE_CXXFLAGS	+= -fno-inline -g3 -O0 -DDEBUG
#linux-g++:QMAKE_CXXFLAGS	+= -finline -pg
#linux-g++:QMAKE_CXXFLAGS	+= -finline

#linux-g++-64:QMAKE_LFLAGS	+= 
#linux-g++-64:QMAKE_CXXFLAGS	+= -fno-inline -g3 -O0 -DDEBUG
#linux-g++-64:QMAKE_CXXFLAGS	+= -finline

#macx-g++:QMAKE_CXXFLAGS	+= -fno-inline
#macx-g++:QMAKE_CXXFLAGS	+= -finline

win32-msvc.net:QMAKE_CXXFLAGS	+= -wd4305 -wd4100 -wd4344 -DNOMINMAX
