static const char * shader_mosaic2_src = 
"//----------------------------------------------------------------\n"
"// decode_la\n"
"// \n"
"float2\n"
"decode_la(float pixel)\n"
"{\n"
"  float2 la;\n"
"  la.x = pixel;\n"
"  la.y = (la.x < (1.0f / 256.0f)) ? 0.0f : 1.0f;\n"
"  \n"
"  return la;\n"
"}\n"
"\n"
"//----------------------------------------------------------------\n"
"// get_la\n"
"// \n"
"float2\n"
"get_la(uniform sampler2D tile_texture,\n"
"       float s,\n"
"       float t)\n"
"{\n"
"  // s = min(1.0, max(0.0, s));\n"
"  // t = min(1.0, max(0.0, t));\n"
"  return decode_la(tex2D(tile_texture, float2(s, t)).r);\n"
"}\n"
"\n"
"//----------------------------------------------------------------\n"
"// main\n"
"// \n"
"void main(float2 st : TEX0,\n"
"	  uniform sampler2D tile_texture,\n"
"	  uniform float2 tile_size,\n"
"	  uniform float3 fi_tint,\n"
"	  uniform float3 mi_tint,\n"
"	  uniform bool antialias,\n"
"	  out float4 frag_color : COLOR)\n"
"{\n"
"#ifndef DISABLE_AA\n"
"  if (antialias)\n"
"  {\n"
"    float nx = tile_size.x / 2.0;\n"
"    float ny = tile_size.y;\n"
"    \n"
"    // lookup the fixed image luminance/alpha data:\n"
"    float ix[2];\n"
"    ix[0] = st.s * nx;\n"
"    ix[1] = floor(ix[0]) + 1.0;\n"
"    \n"
"    float wx[2];\n"
"    wx[1] = ix[0] - (ix[1] - 1.0);\n"
"    wx[0] = 1.0 - wx[1];\n"
"    \n"
"    ix[0] = (ix[1] - 1.0) / nx;\n"
"    ix[1] /= nx;\n"
"    \n"
"    float iy[2];\n"
"    iy[0] = st.t * ny;\n"
"    iy[1] = floor(iy[0]) + 1.0;\n"
"    \n"
"    float wy[2];\n"
"    wy[1] = iy[0] - (iy[1] - 1.0);\n"
"    wy[0] = 1.0 - wy[1];\n"
"    \n"
"    iy[0] = (iy[1] - 1.0) / ny;\n"
"    iy[1] /= ny;\n"
"    \n"
"    float2 fi = (wx[0] * wy[0] * get_la(tile_texture, ix[0], iy[0]) +\n"
"		 wx[1] * wy[0] * get_la(tile_texture, ix[1], iy[0]) +\n"
"		 wx[0] * wy[1] * get_la(tile_texture, ix[0], iy[1]) +\n"
"		 wx[1] * wy[1] * get_la(tile_texture, ix[1], iy[1]));\n"
"    \n"
"    // lookup the moving image luminance/alpha data:\n"
"    float ds = 0.5 / nx;\n"
"    ix[0] += ds;\n"
"    ix[1] += ds;\n"
"    \n"
"    float2 mi = (wx[0] * wy[0] * get_la(tile_texture, ix[0], iy[0]) +\n"
"		 wx[1] * wy[0] * get_la(tile_texture, ix[1], iy[0]) +\n"
"		 wx[0] * wy[1] * get_la(tile_texture, ix[0], iy[1]) +\n"
"		 wx[1] * wy[1] * get_la(tile_texture, ix[1], iy[1]));\n"
"    \n"
"    frag_color = float4((fi_tint * fi.x * fi.y +\n"
"			 mi_tint * mi.x * mi.y),\n"
"			max(fi.y, mi.y));\n"
"  }\n"
"  else\n"
"#endif // DISABLE_AA\n"
"  {\n"
"    float ix[2];\n"
"    \n"
"    float nx = tile_size.x / 2.0;\n"
"    ix[0] = floor(st.s * nx);\n"
"    ix[1] = ix[0] + 0.5;\n"
"    ix[0] /= nx;\n"
"    ix[1] /= nx;\n"
"    \n"
"    float2 fi = get_la(tile_texture, ix[0], st.t);\n"
"    float2 mi = get_la(tile_texture, ix[1], st.t);\n"
"    \n"
"    frag_color = float4((fi_tint * fi.x * fi.y +\n"
"			 mi_tint * mi.x * mi.y),\n"
"			max(fi.y, mi.y));\n"
"  }\n"
"}\n";
