// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : FlipImageTransaction.h
// Author       : Pavel A. Koshevoy
// Created      : Tue Sep 19 16:26:00 MDT 2006
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Transaction for flipping the image in image_data_t structure.

#ifndef FLIP_IMAGE_TRANSACTION_H_
#define FLIP_IMAGE_TRANSACTION_H_

// local includes:
#include "image_data.hxx"

// the includes:
#include <thread/the_thread_interface.hxx>
#include <thread/the_transaction.hxx>


//----------------------------------------------------------------
// FlipImageTransaction
// 
template <typename TImage>
class FlipImageTransaction : public the_transaction_t
{
public:
  FlipImageTransaction(image_data_t & data):
    data_(&data)
  {}
  
  // virtual:
  void execute(the_thread_interface_t * thread)
  {
    blab(thread, tr("flipping the image"));
    data_->tile_generator_.flip();
  }
  
  // trasaction parameters:
  image_data_t * data_;
};


#endif // FLIP_IMAGE_TRANSACTION_H_
