// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : ImageLoaderDialog.h
// Author       : Pavel A. Koshevoy
// Created      : Wed Jul 12 14:20:00 MDT 2006
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : UI for the image loader.

#ifndef IMAGE_LOADER_DIALOG_H_
#define IMAGE_LOADER_DIALOG_H_

// local includes:
#include "ui_ImageLoaderDialog.h"
#include "image_data.hxx"

// thelib includes:
#include <Qt/the_qt_thread.hxx>

// Qt includes:
#include <QDialog>

// forward declarations:
class QFileDialog;


//----------------------------------------------------------------
// ImageLoaderDialog
// 
class ImageLoaderDialog : public QDialog,
			  public Ui::ImageLoaderDialog
{
  Q_OBJECT
  
public:
  ImageLoaderDialog(QWidget * parent = 0, Qt::WFlags f = 0);
  ~ImageLoaderDialog();
  
  int exec(image_data_t & data);
  
public slots:
  void changeSourceFile();
  void load();
  void cancel();
  
protected:
  // virtual:
  void closeEvent(QCloseEvent * e);
  
  // helper:
  void sync_ui();
  
  // helper dialog:
  QFileDialog * file_dialog_;
  
  // the worker:
  the_qt_thread_t thread_;
};


#endif // IMAGE_LOADER_DIALOG_H_
