TEMPLATE	= app
LANGUAGE	= C++
TARGET		= iv
PROJECTNAME	= iv

QT += opengl

CONFIG	-= release
CONFIG	-= debug
CONFIG	+= qt gui rtti exceptions opengl warn_on thread console
#CONFIG	+= debug
CONFIG	+= release

DEFINES += USE_THE_TERMINATORS USE_CG

RESOURCES += iv.qrc

HEADERS	+= \
	the_main_window.hxx \
	the_iv_proc.hxx \
	the_iv_proc_ui.hxx \
        the_thumbnails.hxx \
        PreferencesDialog.h

SOURCES	+= the_main.cxx \
	the_main_window.cxx \
	the_iv_proc.cxx \
	the_iv_proc_ui.cxx \
        the_thumbnails.cxx \
        PreferencesDialog.cpp

FORMS	= MainWindow.ui \
	PreferencesDialog.ui \
        AboutDialog.ui

debug|release {
  QTPLUGIN	+= qjpeg qgif qmng tiffio
}

LIBS	+=	-L$$(THE_BIN_DIR) -lthe_ui_qt -lthe_ui -lthe_core

#LIBS	+= -lefence
macx {
LIBS	+=	-framework Cg -L$$(GLEW_DIR)/lib -lGLEW
} else {
LIBS	+=	-L$$(CG_LIB_DIR) -lCg -lCgGL \
		-Wl,-Bstatic -L$$(GLEW_DIR)/lib -lGLEW -Wl,-Bdynamic
}

INCLUDEPATH +=	$$(THE_SRC_DIR) \
		$$(BOOST_ROOT)/include/boost-1_33_1 \
		$$(GLEW_DIR)/include \
  		$$(CG_DIR)/include

DEPENDPATH	= ./

UI_DIR = ui
MOC_DIR = moc

debug {
  message(configuring DEBUGGING build)
# OBJECTS_DIR = ./obj/$$(CPU)/debug
  OBJECTS_DIR = /scratch/$$(CPU)/iv/debug
  linux-g++:QMAKE_CXXFLAGS	+= -fno-inline -g3 -O0 -DDEBUG
  linux-g++-64:QMAKE_CXXFLAGS	+= -fno-inline -g3 -O0 -DDEBUG
  macx-g++:QMAKE_CXXFLAGS	+= -fno-inline
}

release {
  message(configuring RELEASE build)
# OBJECTS_DIR = ./obj/$$(CPU)/release
  OBJECTS_DIR = /scratch/$$(CPU)/iv/release
  linux-g++:QMAKE_CXXFLAGS	+= -finline
  linux-g++-64:QMAKE_CXXFLAGS	+= -finline
  macx-g++:QMAKE_CXXFLAGS	+= -finline
  DEFINES += NDEBUG
}

win32 {
  RC_FILE = iv.rc
  CONFIG(debug) {
    OBJECTS_DIR = obj\win32dbg
  } else {
    OBJECTS_DIR = obj\win32rel
  }
  
# DEFINES = _USE_MATH_DEFINES NOMINMAX uint64_t=__int64
  DEFINES += _USE_MATH_DEFINES NOMINMAX
  LIBS += -lws2_32 -lsnmpapi -lgdi32

  CONFIG -= console
}

macx {
  ICON = iv.icns
  CONFIG -= console
  UI_DIR = ./osx
  MOC_DIR = ./osx
  
  CONFIG(debug) {
    OBJECTS_DIR = ./osx/$$(CPU)/debug
  } else {
    OBJECTS_DIR = ./osx/$$(CPU)/release
  }
  
  QMAKE_MAC_SDK = /Developer/SDKs/MacOSX10.4u.sdk
#  CONFIG += ppc
  CONFIG += x86 ppc
#  QMAKE_INFO_PLIST = iv.plist
}

win32-msvc.net:QMAKE_CXXFLAGS	+= -wd4305 -wd4100 -wd4344 -DNOMINMAX

exists($$(STLPORT_DIR)) {
INCLUDEPATH *=	$$(STLPORT_DIR)/stlport
LIBS	+= -Wl,-Bstatic -L$$(STLPORT_DIR)/lib -lstlport_gcc -Wl,-Bdynamic
}
