/*=========================================================================

  Program:   Insight Segmentation & Registration Toolkit
  Module:    $RCSfile: invert.cxx,v $
  Language:  C++
  Date:      $Date: 2007/08/05 22:06:26 $
  Version:   $Revision: 1.1 $

  Copyright (c) Insight Software Consortium. All rights reserved.
  See ITKCopyright.txt or http://www.itk.org/HTML/Copyright.htm for details.

     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notices for more information.

=========================================================================*/
#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
#include "itkImageRegionIterator.h"
#include "vnl/vnl_sample.h"
#include "util.h"


const     unsigned int    Dimension = 2;
typedef itk::Image< float, Dimension >  ImageType;


int main(int argc, char* argv[] )
{
  if( argc < 2 )
    {
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " inputImage  outputImage"  << std::endl;
    return 1;
    }


  //
  //  read image
  //
  ImageType::Pointer image = ImageType::New();
  image = load<ImageType>(argv[1]);
  image->Update();

  //
  //  invert
  //
  ImageType::PixelType min;
  ImageType::PixelType max;
  image_min_max<ImageType>(image, min, max);
  remap_min_max_inplace<ImageType>(image, max, min);

  //
  //  save
  //
  save<ImageType>(image, argv[2]);


  return 0;
}
