#include "../track/util.h"
#include "itkInvertIntensityImageFilter.h"


const     unsigned int    Dimension = 2;
typedef itk::Image< float, Dimension >  ImageType;


typedef itk::InvertIntensityImageFilter< ImageType, ImageType >
                           InvertIntensityImageFilter;


int main(int argc, char* argv[] )
{
  if( argc < 2 )
    {
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " inputImage  outputImage"  << std::endl;
    return 1;
    }


  //
  //  read image
  //
  ImageType::Pointer image = ImageType::New();
  image = load<ImageType>(argv[1]);
  image->Update();

  //
  //  invert
  //
  InvertIntensityImageFilter::Pointer invert = InvertIntensityImageFilter::New();
  invert->SetInput( image );
  invert->SetMaximum( 255 );
  invert->Update();


  //
  //  save
  //
  save<ImageType>(invert->GetOutput(), argv[2]);


  return 0;
}
