#include "itkImage.h"
#include "../track/util.h"


const     unsigned int    Dimension = 2;
typedef itk::Image< float, Dimension >  ImageType;


int main(int argc, char* argv[] )
{
  if( argc < 5 )
    {
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " inputImage  outputImage min max"  << std::endl;
    return 1;
    }


  //
  //  read image
  //
  ImageType::Pointer image = ImageType::New();
  image = load<ImageType>(argv[1]);
  image->Update();

  //
  //  rescale 
  //
  image = rescale< ImageType >( image, atof( argv[3] ), atof( argv[4] ) );


  //
  //  save
  //
  save<ImageType>( image, argv[2] );


  return 0;
}
