#ifndef QIO_TIFF_MANGLE_H_
#define QIO_TIFF_MANGLE_H_

/*
This header file mangles all symbols exported from the tiff library.
It is included in all files while building the tiff library.

The following commands were used to obtain the symbol list:

nm .release.obj/tif_*.o | grep " T "
nm .release.obj/tif_*.o | grep " D "
nm .release.obj/tif_*.o | grep " R "
*/

#define display_sRGB                    qio_display_sRGB                   
#define LogL10fromY                     qio_LogL10fromY                    
#define LogL10toY                       qio_LogL10toY                      
#define LogL16fromY                     qio_LogL16fromY                    
#define LogL16toY                       qio_LogL16toY                      
#define LogLuv24fromXYZ                 qio_LogLuv24fromXYZ                
#define LogLuv24toXYZ                   qio_LogLuv24toXYZ                  
#define LogLuv32fromXYZ                 qio_LogLuv32fromXYZ                
#define LogLuv32toXYZ                   qio_LogLuv32toXYZ                  
#define TIFFAccessTagMethods            qio_TIFFAccessTagMethods           
#define _TIFFBuiltinCODECS              qio__TIFFBuiltinCODECS             
#define _TIFFCheckMalloc                qio__TIFFCheckMalloc               
#define TIFFCheckpointDirectory         qio_TIFFCheckpointDirectory        
#define TIFFCheckTile                   qio_TIFFCheckTile                  
#define TIFFCIELabToRGBInit             qio_TIFFCIELabToRGBInit            
#define TIFFCIELabToXYZ                 qio_TIFFCIELabToXYZ                
#define TIFFCleanup                     qio_TIFFCleanup                    
#define TIFFClientdata                  qio_TIFFClientdata                 
#define TIFFClientOpen                  qio_TIFFClientOpen                 
#define TIFFClose                       qio_TIFFClose                      
#define TIFFComputeStrip                qio_TIFFComputeStrip               
#define TIFFComputeTile                 qio_TIFFComputeTile                
#define _TIFFCreateAnonFieldInfo        qio__TIFFCreateAnonFieldInfo       
#define TIFFCreateDirectory             qio_TIFFCreateDirectory            
#define TIFFCurrentDirectory            qio_TIFFCurrentDirectory           
#define TIFFCurrentDirOffset            qio_TIFFCurrentDirOffset           
#define TIFFCurrentRow                  qio_TIFFCurrentRow                 
#define TIFFCurrentStrip                qio_TIFFCurrentStrip               
#define TIFFCurrentTile                 qio_TIFFCurrentTile                
#define TIFFCvtIEEEDoubleToNative       qio_TIFFCvtIEEEDoubleToNative      
#define TIFFCvtIEEEFloatToNative        qio_TIFFCvtIEEEFloatToNative       
#define TIFFCvtNativeToIEEEFloat        qio_TIFFCvtNativeToIEEEFloat       
#define _TIFFDataSize                   qio__TIFFDataSize                  
#define TIFFDataWidth                   qio_TIFFDataWidth                  
#define TIFFDefaultDirectory            qio_TIFFDefaultDirectory           
#define _TIFFDefaultStripSize           qio__TIFFDefaultStripSize          
#define TIFFDefaultStripSize            qio_TIFFDefaultStripSize           
#define _TIFFDefaultTileSize            qio__TIFFDefaultTileSize           
#define TIFFDefaultTileSize             qio_TIFFDefaultTileSize            
#define TIFFErrorExt                    qio_TIFFErrorExt                   
#define _TIFFerrorHandler               qio__TIFFerrorHandler              
#define TIFFError                       qio_TIFFError                      
#define _TIFFFax3fillruns               qio__TIFFFax3fillruns              
#define TIFFFaxBlackCodes               qio_TIFFFaxBlackCodes              
#define _TIFFFaxBlackTable              qio__TIFFFaxBlackTable             
#define TIFFFaxBlackTable               qio_TIFFFaxBlackTable              
#define _TIFFFaxMainTable               qio__TIFFFaxMainTable              
#define TIFFFaxMainTable                qio_TIFFFaxMainTable               
#define TIFFFaxWhiteCodes               qio_TIFFFaxWhiteCodes              
#define _TIFFFaxWhiteTable              qio__TIFFFaxWhiteTable             
#define TIFFFaxWhiteTable               qio_TIFFFaxWhiteTable              
#define TIFFFdOpen                      qio_TIFFFdOpen                     
#define TIFFFieldWithName               qio_TIFFFieldWithName              
#define TIFFFieldWithTag                qio_TIFFFieldWithTag               
#define TIFFFileName                    qio_TIFFFileName                   
#define TIFFFileno                      qio_TIFFFileno                     
#define TIFFFillStrip                   qio_TIFFFillStrip                  
#define TIFFFillTile                    qio_TIFFFillTile                   
#define TIFFFindCODEC                   qio_TIFFFindCODEC                  
#define TIFFFindFieldInfoByName         qio_TIFFFindFieldInfoByName        
#define TIFFFindFieldInfo               qio_TIFFFindFieldInfo              
#define _TIFFFindOrRegisterFieldInfo    qio__TIFFFindOrRegisterFieldInfo   
#define TIFFFlushData1                  qio_TIFFFlushData1                 
#define TIFFFlushData                   qio_TIFFFlushData                  
#define TIFFFlush                       qio_TIFFFlush                      
#define TIFFFreeDirectory               qio_TIFFFreeDirectory              
#define __TIFFfree                      qio___TIFFfree                     
#define _TIFFfree                       qio__TIFFfree                      
#define TIFFGetBitRevTable              qio_TIFFGetBitRevTable             
#define TIFFGetClientInfo               qio_TIFFGetClientInfo              
#define TIFFGetCloseProc                qio_TIFFGetCloseProc               
#define TIFFGetConfiguredCODECs         qio_TIFFGetConfiguredCODECs        
#define _TIFFGetExifFieldInfo           qio__TIFFGetExifFieldInfo          
#define TIFFGetFieldDefaulted           qio_TIFFGetFieldDefaulted          
#define _TIFFGetFieldInfo               qio__TIFFGetFieldInfo              
#define TIFFGetField                    qio_TIFFGetField                   
#define TIFFGetMapFileProc              qio_TIFFGetMapFileProc             
#define _TIFFgetMode                    qio__TIFFgetMode                   
#define TIFFGetMode                     qio_TIFFGetMode                    
#define TIFFGetReadProc                 qio_TIFFGetReadProc                
#define TIFFGetSeekProc                 qio_TIFFGetSeekProc                
#define TIFFGetSizeProc                 qio_TIFFGetSizeProc                
#define TIFFGetTagListCount             qio_TIFFGetTagListCount            
#define TIFFGetTagListEntry             qio_TIFFGetTagListEntry            
#define TIFFGetUnmapFileProc            qio_TIFFGetUnmapFileProc           
#define TIFFGetVersion                  qio_TIFFGetVersion                 
#define TIFFGetWriteProc                qio_TIFFGetWriteProc               
#define TIFFInitCCITTFax3               qio_TIFFInitCCITTFax3              
#define TIFFInitCCITTFax4               qio_TIFFInitCCITTFax4              
#define TIFFInitCCITTRLE                qio_TIFFInitCCITTRLE               
#define TIFFInitCCITTRLEW               qio_TIFFInitCCITTRLEW              
#define TIFFInitDumpMode                qio_TIFFInitDumpMode               
#define TIFFInitJPEG                    qio_TIFFInitJPEG                   
#define TIFFInitLZW                     qio_TIFFInitLZW                    
#define TIFFInitNeXT                    qio_TIFFInitNeXT                   
#define TIFFInitPackBits                qio_TIFFInitPackBits               
#define TIFFInitPixarLog                qio_TIFFInitPixarLog               
#define TIFFInitSGILog                  qio_TIFFInitSGILog                 
#define TIFFInitThunderScan             qio_TIFFInitThunderScan            
#define TIFFInitZIP                     qio_TIFFInitZIP                    
#define TIFFIsBigEndian                 qio_TIFFIsBigEndian                
#define TIFFIsByteSwapped               qio_TIFFIsByteSwapped              
#define TIFFIsCODECConfigured           qio_TIFFIsCODECConfigured          
#define TIFFIsMSB2LSB                   qio_TIFFIsMSB2LSB                  
#define TIFFIsTiled                     qio_TIFFIsTiled                    
#define TIFFIsUpSampled                 qio_TIFFIsUpSampled                
#define TIFFLastDirectory               qio_TIFFLastDirectory              
#define __TIFFmalloc                    qio___TIFFmalloc                   
#define _TIFFmalloc                     qio__TIFFmalloc                    
#define _TIFFmemcmp                     qio__TIFFmemcmp                    
#define _TIFFmemcpy                     qio__TIFFmemcpy                    
#define _TIFFmemset                     qio__TIFFmemset                    
#define TIFFMergeFieldInfo              qio_TIFFMergeFieldInfo             
#define _TIFFNoPostDecode               qio__TIFFNoPostDecode              
#define _TIFFNoPreCode                  qio__TIFFNoPreCode                 
#define _TIFFNoRowDecode                qio__TIFFNoRowDecode               
#define _TIFFNoRowEncode                qio__TIFFNoRowEncode               
#define _TIFFNoSeek                     qio__TIFFNoSeek                    
#define _TIFFNoStripDecode              qio__TIFFNoStripDecode             
#define _TIFFNoStripEncode              qio__TIFFNoStripEncode             
#define _TIFFNoTileDecode               qio__TIFFNoTileDecode              
#define _TIFFNoTileEncode               qio__TIFFNoTileEncode              
#define TIFFNumberOfDirectories         qio_TIFFNumberOfDirectories        
#define TIFFNumberOfStrips              qio_TIFFNumberOfStrips             
#define TIFFNumberOfTiles               qio_TIFFNumberOfTiles              
#define TIFFOpen                        qio_TIFFOpen                       
#define TIFFOpenW                       qio_TIFFOpenW                      
#define TIFFPredictorInit               qio_TIFFPredictorInit              
#define _TIFFprintAscii                 qio__TIFFprintAscii                
#define _TIFFprintAsciiTag              qio__TIFFprintAsciiTag             
#define TIFFPrintDirectory              qio_TIFFPrintDirectory             
#define _TIFFPrintFieldInfo             qio__TIFFPrintFieldInfo            
#define TIFFRasterScanlineSize          qio_TIFFRasterScanlineSize         
#define TIFFRawStripSize                qio_TIFFRawStripSize               
#define TIFFReadBufferSetup             qio_TIFFReadBufferSetup            
#define TIFFReadCustomDirectory         qio_TIFFReadCustomDirectory        
#define TIFFReadDirectory               qio_TIFFReadDirectory              
#define TIFFReadEncodedStrip            qio_TIFFReadEncodedStrip           
#define TIFFReadEncodedTile             qio_TIFFReadEncodedTile            
#define TIFFReadEXIFDirectory           qio_TIFFReadEXIFDirectory          
#define TIFFReadRawStrip                qio_TIFFReadRawStrip               
#define TIFFReadRawTile                 qio_TIFFReadRawTile                
#define TIFFReadRGBAImageOriented       qio_TIFFReadRGBAImageOriented      
#define TIFFReadRGBAImage               qio_TIFFReadRGBAImage              
#define TIFFReadRGBAStrip               qio_TIFFReadRGBAStrip              
#define TIFFReadRGBATile                qio_TIFFReadRGBATile               
#define TIFFReadScanline                qio_TIFFReadScanline               
#define TIFFReadTile                    qio_TIFFReadTile                   
#define _TIFFrealloc                    qio__TIFFrealloc                   
#define TIFFReassignTagToIgnore         qio_TIFFReassignTagToIgnore        
#define TIFFRegisterCODEC               qio_TIFFRegisterCODEC              
#define TIFFReverseBits                 qio_TIFFReverseBits                
#define TIFFRewriteDirectory            qio_TIFFRewriteDirectory           
#define TIFFRGBAImageBegin              qio_TIFFRGBAImageBegin             
#define TIFFRGBAImageEnd                qio_TIFFRGBAImageEnd               
#define TIFFRGBAImageGet                qio_TIFFRGBAImageGet               
#define TIFFRGBAImageOK                 qio_TIFFRGBAImageOK                
#define _TIFFSampleToTagType            qio__TIFFSampleToTagType           
#define TIFFScanlineSize                qio_TIFFScanlineSize               
#define _TIFFsetByteArray               qio__TIFFsetByteArray              
#define TIFFSetClientdata               qio_TIFFSetClientdata              
#define TIFFSetClientInfo               qio_TIFFSetClientInfo              
#define TIFFSetCompressionScheme        qio_TIFFSetCompressionScheme       
#define _TIFFSetDefaultCompressionState qio__TIFFSetDefaultCompressionState
#define TIFFSetDirectory                qio_TIFFSetDirectory               
#define _TIFFsetDoubleArray             qio__TIFFsetDoubleArray            
#define TIFFSetErrorHandlerExt          qio_TIFFSetErrorHandlerExt         
#define TIFFSetErrorHandler             qio_TIFFSetErrorHandler            
#define TIFFSetField                    qio_TIFFSetField                   
#define TIFFSetFileName                 qio_TIFFSetFileName                
#define TIFFSetFileno                   qio_TIFFSetFileno                  
#define _TIFFsetFloatArray              qio__TIFFsetFloatArray             
#define _TIFFsetLongArray               qio__TIFFsetLongArray              
#define TIFFSetMode                     qio_TIFFSetMode                    
#define _TIFFsetNString                 qio__TIFFsetNString                
#define _TIFFsetShortArray              qio__TIFFsetShortArray             
#define _TIFFsetString                  qio__TIFFsetString                 
#define TIFFSetSubDirectory             qio_TIFFSetSubDirectory            
#define TIFFSetTagExtender              qio_TIFFSetTagExtender             
#define _TIFFSetupFieldInfo             qio__TIFFSetupFieldInfo            
#define TIFFSetupStrips                 qio_TIFFSetupStrips                
#define TIFFSetWarningHandlerExt        qio_TIFFSetWarningHandlerExt       
#define TIFFSetWarningHandler           qio_TIFFSetWarningHandler          
#define TIFFSetWriteOffset              qio_TIFFSetWriteOffset             
#define TIFFStripSize                   qio_TIFFStripSize                  
#define _TIFFSwab16BitData              qio__TIFFSwab16BitData             
#define _TIFFSwab24BitData              qio__TIFFSwab24BitData             
#define _TIFFSwab32BitData              qio__TIFFSwab32BitData             
#define _TIFFSwab64BitData              qio__TIFFSwab64BitData             
#define TIFFSwabArrayOfDouble           qio_TIFFSwabArrayOfDouble          
#define TIFFSwabArrayOfLong             qio_TIFFSwabArrayOfLong            
#define TIFFSwabArrayOfShort            qio_TIFFSwabArrayOfShort           
#define TIFFSwabArrayOfTriples          qio_TIFFSwabArrayOfTriples         
#define TIFFSwabDouble                  qio_TIFFSwabDouble                 
#define TIFFSwabLong                    qio_TIFFSwabLong                   
#define TIFFSwabShort                   qio_TIFFSwabShort                  
#define TIFFTileRowSize                 qio_TIFFTileRowSize                
#define TIFFTileSize                    qio_TIFFTileSize                   
#define TIFFUnlinkDirectory             qio_TIFFUnlinkDirectory            
#define TIFFUnRegisterCODEC             qio_TIFFUnRegisterCODEC            
#define TIFFVGetFieldDefaulted          qio_TIFFVGetFieldDefaulted         
#define TIFFVGetField                   qio_TIFFVGetField                  
#define TIFFVSetField                   qio_TIFFVSetField                  
#define TIFFVStripSize                  qio_TIFFVStripSize                 
#define TIFFVTileSize                   qio_TIFFVTileSize                  
#define TIFFWarningExt                  qio_TIFFWarningExt                 
#define _TIFFwarningHandler             qio__TIFFwarningHandler            
#define TIFFWarning                     qio_TIFFWarning                    
#define TIFFWriteBufferSetup            qio_TIFFWriteBufferSetup           
#define TIFFWriteCheck                  qio_TIFFWriteCheck                 
#define TIFFWriteDirectory              qio_TIFFWriteDirectory             
#define TIFFWriteEncodedStrip           qio_TIFFWriteEncodedStrip          
#define TIFFWriteEncodedTile            qio_TIFFWriteEncodedTile           
#define TIFFWriteRawStrip               qio_TIFFWriteRawStrip              
#define TIFFWriteRawTile                qio_TIFFWriteRawTile               
#define TIFFWriteScanline               qio_TIFFWriteScanline              
#define TIFFWriteTile                   qio_TIFFWriteTile                  
#define TIFFXYZToRGB                    qio_TIFFXYZToRGB                   
#define TIFFYCbCrToRGBInit              qio_TIFFYCbCrToRGBInit             
#define TIFFYCbCrtoRGB                  qio_TIFFYCbCrtoRGB                 
#define uv_decode                       qio_uv_decode                      
#define uv_encode                       qio_uv_encode                      
#define XYZtoRGB24                      qio_XYZtoRGB24                     

#endif
