// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_fltk_input_device_event.hxx
// Author       : Pavel A. Koshevoy
// Created      : Sun Aug 29 20:30:00 MDT 2004
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : mouse, keyboard event wrapper classes.

#ifndef THE_FLTK_INPUT_DEVICE_EVENT_HXX_
#define THE_FLTK_INPUT_DEVICE_EVENT_HXX_

// local includes:
#include "math/v3x1p3x1.hxx"
#include "eh/the_input_device_event.hxx"

// FLTK includes:
#include <FL/Fl.H>
#include <FL/Fl_Widget.H>
#include <FL/Enumerations.H>

// system includes:
#include <fstream>
#include <iostream>
#include <stdlib.h>
#include <assert.h>


//----------------------------------------------------------------
// the_mouse_event
// 
extern the_mouse_event_t
the_mouse_event(Fl_Widget * widget, const int & event);

//----------------------------------------------------------------
// the_wheel_event
// 
extern the_wheel_event_t
the_wheel_event(Fl_Widget * widget, const int & event);

//----------------------------------------------------------------
// the_keybd_event
// 
extern the_keybd_event_t
the_keybd_event(Fl_Widget * widget, const int & event);


#endif // THE_FLTK_INPUT_DEVICE_EVENT_HXX_
