# - Try to find Cg
# Once done this will define
#  
#  Cg_FOUND        - system has Cg
#  Cg_INCLUDE_DIR  - the Cg include directory
#  Cg_LIBRARIES    - Link these to use Cg

IF (APPLE)
  FIND_LIBRARY(Cg_LIBRARY Cg DOC "Cg lib for OSX")
  FIND_PATH(Cg_INCLUDE_DIR Cg/cgGL.h DOC "Include for Cg on OSX")

ELSE (APPLE)
  if (WIN32)
    if  (CMAKE_CL_64)
      FILE(TO_CMAKE_PATH "lib/win64/" CRCNS_LIB_DIR)
    ELSE (CMAKE_CL_64)
      FILE(TO_CMAKE_PATH "lib/win32/" CRCNS_LIB_DIR)
    ENDIF (CMAKE_CL_64)
  ELSE (WIN32)
    # Non-windows libraries haven't been built
    FILE(TO_CMAKE_PATH "" CRCNS_LIB_DIR)
  ENDIF (WIN32)

FILE(TO_CMAKE_PATH "$ENV{CG_LIB_DIR}" CG_LIB_DIR)
FILE(TO_CMAKE_PATH "$ENV{CG_DIR}" CG_DIR)


# Path to the CRCNS directory that *hopefully* contains prebuilt
# libraries and binaries.
FILE(TO_CMAKE_PATH "$ENV{CRCNS}" CRCNS)

  FIND_LIBRARY(Cg_LIBRARY Cg 
    ${CG_LIB_DIR}
    ${CRCNS}/${CRCNS_LIB_DIR}/Cg
    DOC "Cg lib"
    )

  FIND_LIBRARY(CgGL_LIBRARY CgGL
    ${CG_LIB_DIR} 
    ${CRCNS}/${CRCNS_LIB_DIR}/Cg
    DOC "CgGL lib"
    )

  FIND_PATH(Cg_INCLUDE_DIR Cg/cgGL.h 
    ${CG_DIR}/include 
    ${CRCNS}/include/Cg
    DOC "Include for Cg"
    )
ENDIF (APPLE)


SET( Cg_FOUND "NO" )
IF(Cg_LIBRARY)

  IF (APPLE)
    SET (Cg_LIBRARIES ${Cg_LIBRARY})
  ELSE (APPLE)
    SET (Cg_LIBRARIES ${Cg_LIBRARY} ${CgGL_LIBRARY})
  ENDIF (APPLE)
  
  IF(Cg_INCLUDE_DIR)
    SET( Cg_FOUND "YES" )
  ELSE(Cg_INCLUDE_DIR)
    SET( Cg_FOUND "NO" )
  ENDIF(Cg_INCLUDE_DIR)
  
ENDIF(Cg_LIBRARY)
