# - Try to find GLEW
# Once done this will define
#  
#  GLEW_FOUND        - system has GLEW
#  GLEW_INCLUDE_DIR  - the GLEW include directory
#  GLEW_LIBRARIES    - Link these to use GLEW

FILE(TO_CMAKE_PATH "$ENV{GLEW_DIR}" GLEW_DIR)
FILE(TO_CMAKE_PATH "$ENV{CRCNS}" CRCNS)

# Determine pre-build path for libraries depending on platform.
IF (WIN32)
  IF  (CMAKE_CL_64)
    FILE(TO_CMAKE_PATH "lib/win64/" CRCNS_LIB_DIR)
  ELSE (CMAKE_CL_64)
    FILE(TO_CMAKE_PATH "lib/win32/" CRCNS_LIB_DIR)
  ENDIF (CMAKE_CL_64)
ELSE (WIN32)
  # Non-windows libraries haven't been built
  FILE(TO_CMAKE_PATH "" CRCNS_LIB_DIR)
ENDIF (WIN32)
#MESSAGE("${CRCNS}/${CRCNS_LIB_DIR}/glew")

FIND_LIBRARY(GLEW_LIBRARY GLEW
  ${GLEW_DIR}/lib 
  ${CRCNS}/${CRCNS_LIB_DIR}/glew
  DOC "GLEW lib"
)

IF (NOT GLEW_LIBRARY)
  # Sometimes glew is named glew32.lib, if it can't find the library
  # try glew32 before giving up.
  FIND_LIBRARY(GLEW_LIBRARY GLEW32
    ${GLEW_DIR}/lib 
    ${CRCNS}/${CRCNS_LIB_DIR}/glew
    DOC "GLEW lib"
  )
ENDIF (NOT GLEW_LIBRARY)

FIND_PATH(GLEW_INCLUDE_DIR GL/glew.h 
  ${GLEW_DIR}/include 
  ${CRCNS}/include/glew
  DOC "Include for GLEW"
)

SET( GLEW_FOUND "NO" )
IF(GLEW_LIBRARY)
  
  SET( GLEW_LIBRARIES  ${GLEW_LIBRARY} ${GLEW_LIBRARIES})
  
  IF(GLEW_INCLUDE_DIR)
    SET( GLEW_FOUND "YES" )
  ELSE(GLEW_INCLUDE_DIR)
    SET( GLEW_FOUND "NO" )
  ENDIF(GLEW_INCLUDE_DIR)
  
ENDIF(GLEW_LIBRARY)
