// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : DebugMutex.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Jul  1 21:53:36 MDT 2002
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A chatty mutex class, may be useful when debugging.

#ifndef DEBUG_MUTEX_H_
#define DEBUG_MUTEX_H_

// Qt includes:
#include <QMutex>


//----------------------------------------------------------------
// DebugMutex
// 
class DebugMutex : public QMutex
{
public:
  inline void lock()
  {
    std::cerr << "mutex " << this << " -> lock" << std::endl;
    QMutex::lock();
  }
  
  bool tryLock()
  {
    bool ok = QMutex::tryLock();
    std::cerr << "mutex " << this << " -> tryLock: " << ok << std::endl;
    return ok;
  }
  
  void unlock()
  {
    std::cerr << "mutex " << this << " -> unlock" << std::endl;
    QMutex::unlock();
  }
};


#endif // DEBUG_MUTEX_H_
