// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_qt_desktop_metrics.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Feb 5 16:11:00 MST 2007
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : The Qt wrapper for desktop metrics (DPI)

#ifndef THE_QT_DESKTOP_METRICS_HXX_
#define THE_QT_DESKTOP_METRICS_HXX_

// local includs:
#include "ui/the_desktop_metrics.hxx"

// Qt includes:
#include <QApplication>
#include <QPaintDevice>
#include <QDesktopWidget>


//----------------------------------------------------------------
// the_qt_desktop_metrics_t
// 
class the_qt_desktop_metrics_t : public the_desktop_metrics_t
{
public:
  // virtual:
  float dpi_x() const
  {
    const QPaintDevice & qpdm = *(QApplication::desktop());
    float dpi = (float)(qpdm.logicalDpiX());
    return dpi;
  }
  
  float dpi_y() const
  {
    const QPaintDevice & qpdm = *(QApplication::desktop());
    float dpi = (float)(qpdm.logicalDpiY());
    return dpi;
  }
};


#endif // THE_QT_DESKTOP_METRICS_HXX_
