// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_qt_input_device_event.hxx
// Author       : Pavel A. Koshevoy
// Created      : 2007/01/05 14:58:00
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Qt wrappers for input device events

#ifndef THE_QT_INPUT_DEVICE_EVENT_HXX_
#define THE_QT_INPUT_DEVICE_EVENT_HXX_

// local includes:
#include "eh/the_input_device_event.hxx"

// forward declarations:
class QWidget;
class QMouseEvent;
class QWheelEvent;
class QKeyEvent;
class QTabletEvent;


//----------------------------------------------------------------
// the_mouse_event
// 
extern the_mouse_event_t
the_mouse_event(QWidget * widget, const QMouseEvent * e);

//----------------------------------------------------------------
// the_wheel_event
// 
extern the_wheel_event_t
the_wheel_event(QWidget * widget, const QWheelEvent * e);

//----------------------------------------------------------------
// the_keybd_event
// 
extern the_keybd_event_t
the_keybd_event(QWidget * widget, const QKeyEvent * e);

//----------------------------------------------------------------
// the_wacom_event
// 
extern the_wacom_event_t
the_wacom_event(QWidget * widget, const QTabletEvent * e);


#endif // THE_QT_INPUT_DEVICE_EVENT_HXX_
