// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_qt_thread_pool.cxx
// Author       : Pavel A. Koshevoy
// Created      : Wed Feb 21 11:29:00 MST 2007
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A Qt based thread pool class.

// local includes:
#include "Qt/the_qt_thread_pool.hxx"

//----------------------------------------------------------------
// the_qt_thread_pool_t::the_qt_thread_pool_t
// 
the_qt_thread_pool_t::the_qt_thread_pool_t(unsigned int num_threads):
  QObject(),
  the_thread_pool_t(num_threads)
{}

//----------------------------------------------------------------
// the_qt_thread_pool_t::handle
// 
void
the_qt_thread_pool_t::handle(the_transaction_t * transaction,
			     the_transaction_t::state_t s)
{
  switch (s)
  {
    case the_transaction_t::STARTED_E:
      emit transaction_started(transaction);
      break;
      
    case the_transaction_t::SKIPPED_E:
    case the_transaction_t::ABORTED_E:
    case the_transaction_t::DONE_E:
      emit transaction_finished(transaction);
      break;
      
    default:
      break;
  }
}

//----------------------------------------------------------------
// the_qt_thread_pool_t::blab
// 
void
the_qt_thread_pool_t::blab(const char * message) const
{
  emit status_update(QString(message));
}
