// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_procedure.hxx
// Author       : Pavel A. Koshevoy
// Created      : Tue Apr 04 15:32:30 MDT 2004
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A document procedure class -- a container for
//                inter related document primitives.

#ifndef THE_PROCEDURE_HXX_
#define THE_PROCEDURE_HXX_

// local includes:
#include "doc/the_primitive.hxx"
#include "utils/the_text.hxx"
#include "utils/the_indentation.hxx"

// forward declarations:
class the_bbox_t;
class the_view_t;


//----------------------------------------------------------------
// the_procedure_t
// 
class the_procedure_t : public the_primitive_t
{
public:
  the_procedure_t(): the_primitive_t() {}
  
  // display the geometry:
  virtual void draw(const the_view_t & view) const = 0;
  
  // calculate the model bounding box:
  virtual void calc_bbox(const the_view_t & view, the_bbox_t & bbox) const = 0;
  
  // virtual: For debugging, dumps the value
  void dump(ostream & strm, unsigned int indent = 0) const
  {
    strm << INDSCP << "the_procedure_t(" << (void *)this << ")" << endl
	 << INDSCP << "{" << endl;
    the_primitive_t::dump(strm, INDNXT);
    strm << INDSCP << "}" << endl << endl;
  }
};


#endif // THE_PROCEDURE_HXX_
