// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_reference.cxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Jul  1 21:53:36 MDT 2002
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A reference object used to establish graph dependencies
//                between document primitives.

// local includes:
#include "doc/the_reference.hxx"
#include "utils/the_indentation.hxx"
#include "io/the_file_io.hxx"


//----------------------------------------------------------------
// the_reference_t::the_reference_t
// 
the_reference_t::the_reference_t(const unsigned int & id):
  id_(id)
{}

//----------------------------------------------------------------
// the_reference_t::save
// 
bool
the_reference_t::save(std::ostream & stream) const
{
  ::save(stream, id_);
  return true;
}

//----------------------------------------------------------------
// the_reference_t::load
// 
bool
the_reference_t::load(std::istream & stream)
{
  return ::load(stream, id_);
}

//----------------------------------------------------------------
// the_reference_t::dump
// 
void
the_reference_t::dump(ostream & strm, unsigned int indent) const
{
  strm << INDSCP << "the_reference_t(" << (void *)this << ")" << endl
       << INDSCP << "{" << endl
       << INDSTR << "id_ = " << id_ << endl
       << INDSCP << "}" << endl << endl;
}
