// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_document_eh.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Aug 23 19:38:00 MDT 2004
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Event handler base class for the document.

#ifndef THE_DOCUMENT_EH_HXX_
#define THE_DOCUMENT_EH_HXX_

// local includes:
#include "eh/the_input_device_eh.hxx"
#include "ui/the_document_ui.hxx"
#include "doc/the_document_so.hxx"
#include "doc/the_document.hxx"


//----------------------------------------------------------------
// the_document_eh_t
//
template <class doc_t>
class the_document_eh_t : public the_input_device_eh_t
{
public:
  the_document_eh_t(the_document_ui_t * doc_ui):
    doc_ui_(doc_ui)
  {}
  
  // accessor to the document ui:
  inline the_document_ui_t & doc_ui() const
  { return *doc_ui_; }
  
  // accessors to the document state object:
  inline the_document_so_t & doc_so()
  { return doc_ui_->doc_so(); }
  
  inline const the_document_so_t & doc_so() const
  { return doc_ui_->doc_so(); }
  
  // accessor to the document:
  inline doc_t * document() const
  { return dynamic_cast<doc_t *>(doc_so().document()); }
  
private:
  the_document_ui_t * doc_ui_;
};


#endif // THE_DOCUMENT_EH_HXX_
