// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_input_device.hxx
// Author       : Pavel A. Koshevoy
// Created      : 2001/06/24 16:47:24
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : base class for mouse, keyboard and tablet devices.

#ifndef THE_INPUT_DEVICE_HXX_
#define THE_INPUT_DEVICE_HXX_


//----------------------------------------------------------------
// the_input_device_t
// 
class the_input_device_t
{
public:
  the_input_device_t()
  { time_stamp_ = latest_time_stamp_; }
  
  inline void update_time_stamp()
  { time_stamp_ = latest_time_stamp_; }
  
  inline bool current() const
  { return (time_stamp_ == latest_time_stamp_); }
  
  inline static void advance_time_stamp()
  { latest_time_stamp_++; }
  
  inline const unsigned int & time_stamp() const
  { return time_stamp_; }
  
  inline static unsigned int latest_time_stamp()
  { return latest_time_stamp_; }
  
protected:
  unsigned int time_stamp_;
  
  static unsigned int latest_time_stamp_;
};


//----------------------------------------------------------------
// the_btn_state_t
// 
typedef enum
{
  THE_BTN_UP_E = 0,
  THE_BTN_DN_E = 1
} the_btn_state_t;


#endif // THE_INPUT_DEVICE_HXX_
