#!/bin/csh

if ( ! ${?CPU} ) then
    setenv CPU `uname -p`
endif

if ( ${CPU} == "unknown" ) then
    set OS = `uname -o`
    if ( ${OS} == "Cygwin" ) then
	setenv CPU w32
    endif
endif

# determine where ITK lives:
if ( -e /scratch/ITK ) then
    setenv ITK_SOURCE_DIR /scratch/ITK
else if ( -e /usr/sci/crcnsdata/ITK ) then
    setenv ITK_SOURCE_DIR /usr/sci/crcnsdata/ITK
endif

if ( -e /scratch/"${CPU}"/ITK ) then
    setenv ITK_BINARY_DIR /scratch/"${CPU}"/ITK
else if ( -e /usr/sci/crcnsdata/"${CPU}"/ITK ) then
    setenv ITK_BINARY_DIR /usr/sci/crcnsdata/"${CPU}"/ITK
endif

# determine where Qt4 lives:
if ( -e /scratch/"${CPU}"/Qt ) then
    setenv QT4_DIR /scratch/"${CPU}"/Qt
else if ( -e /usr/sci/crcnsdata/"${CPU}"/Qt ) then
    setenv QT4_DIR /usr/sci/crcnsdata/"${CPU}"/Qt
endif

# determine where GLEW lives:
if ( -e /scratch/"${CPU}"/GLEW ) then
    setenv GLEW_DIR /scratch/"${CPU}"/GLEW
else if ( -e /usr/sci/crcnsdata/"${CPU}"/GLEW ) then
    setenv GLEW_DIR /usr/sci/crcnsdata/"${CPU}"/GLEW
endif

# determine where Cg lives:
if ( -e /scratch/"${CPU}"/Cg ) then
    setenv CG_DIR /scratch/"${CPU}"/Cg
else if ( -e /usr/sci/crcnsdata/"${CPU}"/Cg ) then
    setenv CG_DIR /usr/sci/crcnsdata/"${CPU}"/Cg
endif

# determine where FFTW lives:
if ( -e /scratch/"${CPU}"/FFTW ) then
    setenv FFTW_DIR /scratch/"${CPU}"/FFTW
else if ( -e /usr/sci/crcnsdata/"${CPU}"/FFTW ) then
    setenv FFTW_DIR /usr/sci/crcnsdata/"${CPU}"/FFTW
endif

# determine where BOOST lives:
if ( -e /scratch/"${CPU}"/BOOST ) then
    setenv BOOST_DIR /scratch/"${CPU}"/BOOST
else if ( -e /usr/sci/crcnsdata/"${CPU}"/BOOST ) then
    setenv BOOST_DIR /usr/sci/crcnsdata/"${CPU}"/BOOST
endif

# determine where THE libraries live:
if ( -e "${HOME}"/src/CRCNS/the ) then
    setenv THE_SRC_DIR "${HOME}"/src/CRCNS/the
endif

if ( -e /scratch/"${CPU}"/the ) then
    setenv THE_BIN_DIR /scratch/"${CPU}"/the
else if ( -e /usr/sci/crcnsdata/"${CPU}"/the ) then
    setenv THE_BIN_DIR /usr/sci/crcnsdata/"${CPU}"/the
endif
