#!/bin/bash

if [ -z "${CPU}" ]; then
    export CPU=`uname -p`;
fi

if [ ${CPU} = "unknown" ]; then
    OS=`uname -o`
    if [ ${OS} = "Cygwin" ]; then
       export CPU=w32
    fi
fi

# determine where ITK lives:
#if [ -e /scratch/ITK ]; then
#    export ITK_SOURCE_DIR=/scratch/ITK
#elif [ -e /usr/sci/crcnsdata/ITK ]; then
#    export ITK_SOURCE_DIR=/usr/sci/crcnsdata/ITK
#fi
#
#if [ -e /scratch/"${CPU}"/ITK ]; then
#    export ITK_BINARY_DIR=/scratch/"${CPU}"/ITK
#elif [ -e /usr/sci/crcnsdata/"${CPU}"/ITK ]; then
#    export ITK_BINARY_DIR=/usr/sci/crcnsdata/"${CPU}"/ITK
#fi

# determine where Qt3 lives:
if [ -e /usr/lib/qt3 ]; then
    export QT3_DIR=/usr/lib/qt3
fi

# determine where Qt4 lives:
if [ -e /scratch/"${CPU}"/Qt ]; then
    export QT4_DIR=/scratch/"${CPU}"/Qt
elif [ -e /usr/sci/crcnsdata/"${CPU}"/Qt ]; then
    export QT4_DIR=/usr/sci/crcnsdata/"${CPU}"/Qt
elif [ -e /usr/include/QtCore ]; then
    export QT4_DIR=/usr
elif [ -e /usr/lib/libQtCore.so ]; then
    export QT4_DIR=/usr
fi

# determine where GLEW lives:
if [ -e /scratch/"${CPU}"/GLEW ]; then
    export GLEW_DIR=/scratch/"${CPU}"/GLEW
elif [ -e /usr/sci/crcnsdata/"${CPU}"/GLEW ]; then
    export GLEW_DIR=/usr/sci/crcnsdata/"${CPU}"/GLEW
elif [ -e /usr/include/GL/glew.h ]; then
    export GLEW_DIR=/usr
elif [ -e /usr/lib/libGLEW.so ]; then
    export GLEW_DIR=/usr
fi

# determine where Cg lives:
if [ -e /scratch/"${CPU}"/Cg ]; then
    export CG_DIR=/scratch/"${CPU}"/Cg
elif [ -e /usr/sci/crcnsdata/"${CPU}"/Cg ]; then
    export CG_DIR=/usr/sci/crcnsdata/"${CPU}"/Cg
elif [ -e /usr/include/Cg/cgGL.h ]; then
    export CG_DIR=/usr
elif [ -e /usr/lib/libCg.so ]; then
    export CG_DIR=/usr
fi

# determine where FFTW lives:
if [ -e /scratch/"${CPU}"/FFTW ]; then
    export FFTW_DIR=/scratch/"${CPU}"/FFTW
elif [ -e /usr/sci/crcnsdata/"${CPU}"/FFTW ]; then
    export FFTW_DIR=/usr/sci/crcnsdata/"${CPU}"/FFTW
elif [ -e /usr/include/fftw3.h ]; then
    export FFTW_DIR=/usr
elif [ -e /usr/lib/libfftw3.so ]; then
    export FFTW_DIR=/usr
fi

# determine where FLTK lives:
if [ -e /usr/X11R6/include/FL ]; then
    export FLTK_DIR=/usr/X11R6
fi

# determine where THE libraries live:
if [ -e "${HOME}/CRCNS/trunk/code/the" ]; then
    export THE_SRC_DIR="${HOME}/CRCNS/trunk/code/the"
elif [ -e "${HOME}/crcns/trunk/code/the" ]; then
    export THE_SRC_DIR="${HOME}/crcns/trunk/code/the"
elif [ -e "/scratch/crcns/src/the" ]; then
    export THE_SRC_DIR=/scratch/crcns/src/the
fi

if [ -e "/scratch/${CPU}/crcns/the" ]; then
    export THE_BIN_DIR="/scratch/${CPU}/crcns/the"
elif [ -e "${HOME}/CRCNS/build/the" ]; then
    export THE_BIN_DIR="${HOME}/CRCNS/build/the"
elif [ -e "${HOME}/${CPU}/build/the" ]; then
    export THE_BIN_DIR="${HOME}/${CPU}"/build/the
elif [ -e /scratch/"${CPU}"/the ]; then
    export THE_BIN_DIR=/scratch/"${CPU}"/the
elif [ -e /usr/sci/crcnsdata/"${CPU}"/the ]; then
    export THE_BIN_DIR=/usr/sci/crcnsdata/"${CPU}"/the
fi
