// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_font.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Jul  1 21:53:36 MDT 2002
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : An OpenGL bitmap font class.

#ifndef THE_FONT_HXX_
#define THE_FONT_HXX_

// local includes:
#include "opengl/the_symbols.hxx"


//----------------------------------------------------------------
// the_font_t
// 
class the_font_t : public the_symbols_t
{
public:
  the_font_t(const the_text_t & n): the_symbols_t(n) {}
  
  // virtual: the number of display lists to be compiled:
  unsigned int size() const { return 128; }
  
  void print(const the_text_t & str,
	     const p3x1_t & pos,
	     const the_color_t & color) const;
  
  void print(const the_text_t & str,
	     const p3x1_t & pos,
	     const the_color_t & font_color,
	     const the_color_t & mask_color) const;
  
  void print_mask(const the_text_t & str,
		  const p3x1_t & pos,
		  const the_color_t & color) const;
  
protected:
  // disable default constructor:
  the_font_t();
};

  
#endif // THE_FONT_HXX_
