// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_gl_context.hxx
// Author       : Pavel A. Koshevoy
// Created      : Wed Jan 31 11:07:00 MST 2007
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : An OpenGL rendering context wrapper class.

#ifndef THE_GL_CONTEXT_HXX_
#define THE_GL_CONTEXT_HXX_

// forward declaration:
class the_view_t;


//----------------------------------------------------------------
// the_gl_context_t
// 
// Abstract class for toolkit-independent opengl context API.
// A subclass must be made for each toolkit.
// 
class the_gl_context_t
{
public:
  the_gl_context_t(the_view_t * view = NULL);
  ~the_gl_context_t();
  
  void make_current();
  void done_current();
  bool is_valid() const;
  void invalidate();
  
  static the_gl_context_t current();
  
protected:
  the_view_t * view_;
};


#endif // THE_GL_CONTEXT_HXX_
