// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_view_mgr_orientation.cxx
// Author       : Pavel A. Koshevoy
// Created      : Sun May 30 19:58:00 MDT 2004
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Predefined view orientations.

// system includes:
#include <assert.h>

// local includes:
#include "opengl/the_view_mgr_orientation.hxx"


//----------------------------------------------------------------
// the_view_name
// 
const char *
the_view_orientation_text(const the_view_mgr_orientation_t & orientation)
{
  switch (orientation)
  {
    case THE_ISOMETRIC_VIEW_E:	return "Isometric";
    case THE_TOP_VIEW_E:	return "Top";
    case THE_BOTTOM_VIEW_E:	return "Bottom";
    case THE_LEFT_VIEW_E:	return "Left";
    case THE_RIGHT_VIEW_E:	return "Right";
    case THE_FRONT_VIEW_E:	return "Front";
    case THE_BACK_VIEW_E:	return "Back";
    case THE_XY_VIEW_E:		return "XY";
  }
  
  assert(false);
  return NULL;
}

//----------------------------------------------------------------
// THE_ORIENTATION_LF
// 
// this array should be accessed via the_view_type_t:
// 
const v3x1_t
THE_ORIENTATION_LF[] =
{
  !v3x1_t( 1.0,  1.0,  1.0), // isometric
  v3x1_t(  0.0,  0.0,  1.0), // top
  v3x1_t(  0.0,  0.0, -1.0), // bottom
  v3x1_t(  0.0,  1.0,  0.0), // left
  v3x1_t(  0.0, -1.0,  0.0), // right
  v3x1_t(  1.0,  0.0,  0.0), // front
  v3x1_t( -1.0,  0.0,  0.0), // back
  v3x1_t(  0.0,  0.0,  1.0)  // bottom
};

//----------------------------------------------------------------
// THE_ORIENTATION_UP
// 
// this array should be accessed via the_view_type_t:
// 
const v3x1_t
THE_ORIENTATION_UP[] =
{
  !v3x1_t(-1.0, -1.0, 2.0), // isometric
  v3x1_t(  0.0, -1.0, 0.0), // top
  v3x1_t(  0.0, -1.0, 0.0), // bottom
  v3x1_t(  0.0,  0.0, 1.0), // left
  v3x1_t(  0.0,  0.0, 1.0), // right
  v3x1_t(  0.0,  0.0, 1.0), // front
  v3x1_t(  0.0,  0.0, 1.0), // back
  v3x1_t(  0.0,  1.0, 0.0)  // xy
};
