// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_pick_filter.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Jul  1 21:53:36 MDT 2002
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Basic selection filters for document primitives.

#ifndef THE_PICK_FILTER_HXX_
#define THE_PICK_FILTER_HXX_

// local includes:
#include "doc/the_registry.hxx"


//----------------------------------------------------------------
// the_pick_filter_t
//
class the_pick_filter_t
{
public:
  virtual ~the_pick_filter_t() {}
  
  virtual bool allow(const the_registry_t * registry,
		     const unsigned int & id) const
  { return registry->elem(id) != NULL; }
};

//----------------------------------------------------------------
// the_pick_filter_t<prim_t>
// 
template <class prim_t>
class the_pick_filter : public the_pick_filter_t
{
public:
  // virtual:
  bool allow(const the_registry_t * registry,
	     const unsigned int & id) const
  { return dynamic_cast<prim_t *>(registry->elem(id)) != NULL; }
};


#endif // THE_PICK_FILTER_HXX_
