// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_selset.cxx
// Author       : Pavel A. Koshevoy
// Created      : Sat Jan 22 13:03:00 MDT 2005
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A basic selection set.

// the includes:
#include <sel/the_selset.hxx>
#include <ui/the_document_ui.hxx>
#include <doc/the_document.hxx>


//----------------------------------------------------------------
// the_selset_traits_t::clone
// 
the_selset_traits_t::super_t *
the_selset_traits_t::clone() const
{
  return new the_selset_traits_t(*this);
}

//----------------------------------------------------------------
// the_selset_traits_t::is_valid
// 
bool
the_selset_traits_t::is_valid(const unsigned int & id) const
{
  return registry()->elem(id) != NULL;
}

//----------------------------------------------------------------
// the_selset_traits_t::activate
// 
bool
the_selset_traits_t::activate(unsigned int & id) const
{
  if (!is_valid(id))
  {
    return false;
  }
  
  registry()->elem(id)->set_current_state(THE_SELECTED_STATE_E);
  return true;
}

//----------------------------------------------------------------
// the_selset_traits_t::deactivate
// 
bool
the_selset_traits_t::deactivate(unsigned int & id) const
{
  if (!is_valid(id))
  {
    return false;
  }
  
  registry()->elem(id)->clear_state(THE_SELECTED_STATE_E);
  return true;
}
