// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_desktop_metrics.cxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Feb 5 16:02:00 MST 2007
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : The base class for desktop metrics (DPI)


// system includes:
#include <stdlib.h>

// local includes:
#include "ui/the_desktop_metrics.hxx"
#include "utils/the_dynamic_array.hxx"

//----------------------------------------------------------------
// metrics
// 
static the_dynamic_array_t<the_desktop_metrics_t *> metrics(0, 1, NULL);

//----------------------------------------------------------------
// the_desktop_metrics
// 
const the_desktop_metrics_t *
the_desktop_metrics(unsigned int desktop)
{
  if (desktop >= metrics.size())
  {
    return NULL;
  }
  
  return metrics[desktop];
}

//----------------------------------------------------------------
// the_desktop_metrics
// 
void
the_desktop_metrics(the_desktop_metrics_t * m, unsigned int desktop)
{
  if (desktop >= metrics.size())
  {
    metrics.resize(desktop + 1);
    metrics[desktop] = m;
  }
  else
  {
    delete metrics[desktop];
    metrics[desktop] = m;
  }
}
