// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_desktop_metrics.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Feb 5 15:51:00 MST 2007
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : The base class for desktop metrics (DPI)

#ifndef THE_DESKTOP_METRICS_HXX_
#define THE_DESKTOP_METRICS_HXX_


//----------------------------------------------------------------
// the_desktop_metrics_t
// 
class the_desktop_metrics_t
{
public:
  virtual ~the_desktop_metrics_t() {}
  
  // dots per inch:
  virtual float dpi_x() const
  {
#ifdef __APPLE__
    return 72;
#else
    return 96;
#endif
  }
  
  virtual float dpi_y() const
  {
#ifdef __APPLE__
    return 72;
#else
    return 96;
#endif
  }
  
  inline float pixels_per_inch() const
  { return dpi_x(); }
  
  inline float pixels_per_millimeter() const
  {
    // 1 inch == 25.4 millimeters:
    return pixels_per_inch() / 25.4;
  }
};

//----------------------------------------------------------------
// the_desktop_metrics
// 
extern const the_desktop_metrics_t *
the_desktop_metrics(unsigned int desktop = 0);

//----------------------------------------------------------------
// the_desktop_metrics
// 
extern void
the_desktop_metrics(the_desktop_metrics_t * m, unsigned int desktop = 0);


#endif // THE_DESKTOP_METRICS_HXX_
