// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : debug.hxx
// Author       : Pavel A. Koshevoy
// Created      : Mon Jul  1 21:53:36 MDT 2002
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Helper functions used for debugging.

#ifndef DEBUG_HXX_
#define DEBUG_HXX_

// system includes:
#include <iostream>
#include <iomanip>
#include <exception>
#include <new>
#include <stdlib.h>

//----------------------------------------------------------------
// FIXME
// 
#define FIXME( note ) \
_FIXME( note, __FILE__, __LINE__ )

//----------------------------------------------------------------
// _FIXME
// 
extern void
_FIXME(const char * note, const char * file_name, int line_num);


//----------------------------------------------------------------
// the_assertion
// 
#define the_assertion( expr ) ((expr) ? ((void) 0) : \
_the_failed_assertion(#expr, __FILE__, __LINE__ )

//----------------------------------------------------------------
// _the_failed_assertion
// 
extern void
_the_failed_assertion(const char * expr, const char * file_name, int line_num);

// for memory leak debugging:
#ifdef DEBUG_MEMORY
extern void * operator new (std::size_t size) throw(std::bad_alloc);
extern void operator delete (void * ptr) throw();
extern void dump_new_delete_stats();
#endif // DEBUG_MEMORY

//----------------------------------------------------------------
// put_breakpoint_here
// 
extern void put_breakpoint_here();


#endif // DEBUG_HXX_
