// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : histogram.hxx
// Author       : Pavel A. Koshevoy
// Created      : 2006/04/05 12:36
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Helper functions for working with circular histograms.

#ifndef HISTOGRAM_HXX_
#define HISTOGRAM_HXX_

//----------------------------------------------------------------
// smoothout_orientation_histogram
// 
extern void
smoothout_orientation_histogram(double * orientation,
				const unsigned int & bins,
				const unsigned int iterations = 3);

//----------------------------------------------------------------
// isolate_orientation_histogram_peaks
// 
extern bool
isolate_orientation_histogram_peaks(double * histogram,
				    const unsigned int & bins,
				    const bool normalize = false);

//----------------------------------------------------------------
// calc_histogram_donations
// 
extern unsigned int
calc_histogram_donations(const unsigned int & bins,
			 const double & r0,
			 const double & r1,
			 const double & r,
			 unsigned int * donation_bin,
			 double * donation);

//----------------------------------------------------------------
// calc_orientation_histogram_donations
// 
extern unsigned int
calc_orientation_histogram_donations(const unsigned int & bins,
				     const double & angle,
				     unsigned int * donation_bin,
				     double * donation);

//----------------------------------------------------------------
// update_orientation_histogram
// 
extern void
update_orientation_histogram(double * orientation,
			     const unsigned int & bins,
			     const double & angle,
			     const double & value);


#endif // HISTOGRAM_HXX_
