// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_bit_tree.cxx
// Author       : Pavel A. Koshevoy
// Created      : 2003/01/21 17:11
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : A structure for order O(log(n)) lookup of
//                arbitrary memory pointers.

// local includes:
#include "utils/the_bit_tree.hxx"

// system includes:
#include <iostream>
#include <iomanip>


//----------------------------------------------------------------
// the_bit_tree_node_t::node_size
// 
const uint64_t
the_bit_tree_node_t::node_size[] =
{
  0,   // 0 bits
  2,   // 1 bit
  4,   // 2 bits
  8,   // 3 bits
  16,  // 4 bits
  32,  // 5 bits
  64,  // 6 bits
  128, // 7 bits
  256  // 8 bits
};

//----------------------------------------------------------------
// the_bit_tree_node_t::node_mask
// 
const uint64_t
the_bit_tree_node_t::node_mask[] =
{
  0x00, // 0 bits
  0x01, // 1 bit
  0x03, // 2 bits
  0x07, // 3 bits
  0x0F, // 4 bits
  0x1F, // 5 bits
  0x3F, // 6 bits
  0x7F, // 7 bits
  0xFF  // 8 bits
};
