// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : the_dlink.hxx
// Author       : Pavel A. Koshevoy
// Created      : Tue Jul  5 11:40:00 MDT 2005
// Copyright    : (C) 2004-2008 University of Utah
// License      : GPLv2
// Description  : Single element container with pointers to preceeding and
//                successive container, to be used in a double-linked list.

#ifndef THE_DLINK_HXX_
#define THE_DLINK_HXX_


//----------------------------------------------------------------
// the_dlink_t
// 
// the_dlink_t is a helper class used to implement a linked list,
// a stack, and a loop of objects:
template<class T>
class the_dlink_t
{
public:
  // constructor (an element is required, the next link pointer is optional):
  the_dlink_t(const T & ref_to_elem,
	      the_dlink_t * ptr_to_prev = 0,
	      the_dlink_t * ptr_to_next = 0):
    elem(ref_to_elem),
    prev(ptr_to_prev),
    next(ptr_to_next)
  {}
  
  // the element contained in this link:
  T elem;
  
  // pointers to the previous/next link:
  the_dlink_t<T> * prev;
  the_dlink_t<T> * next;
  
private:
  // disable the default constructor:
  the_dlink_t();
};


#endif // THE_DLINK_HXX_
